
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_SearchForCall' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCall
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCall
	@idoperator uniqueidentifier,
	@taskid uniqueidentifier,
	@cols nvarchar ( 1000 ),
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@search nvarchar ( 4000 ) = '',
	@states nvarchar ( 4000 ) = '',
	@dtnow datetime = NULL,
	@partindex int = 0,
	@partcount int = 1000,
	@totalrowcount int OUTPUT
as
begin

----------------------------------------------------------------------
/*
declare @idoperator uniqueidentifier
select @idoperator = id from A_Users Where login like 'Peter'

declare @taskid uniqueidentifier
set @taskid = 'C5D4BCB0-3831-432E-A611-ACBBAD6FFACC'

declare @cols nvarchar ( 1000 )
set @cols = ', Nm'

declare @table nvarchar ( 100 )
set @table = 'dbo.t1'

declare @query nvarchar ( 1000 )
set @query = ''

declare @search nvarchar ( 1000 )
set @search = 'Nm like ''%%'''

declare @states nvarchar ( 4000 )
set @states = '6:0,5:1,11:1,0:2'
*/
--------------------------------------------------------------------------

	if ( @dtnow is null )
		set @dtnow = GetDate()

	declare @operator nvarchar ( 100 )
	set @operator = '''' + cast ( @idoperator as nvarchar ( 100 ) ) + ''''

	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tmptable nvarchar ( 100 )
	set @tmptable = 'dbo.[t_cachex_' + cast ( NewId ( ) as nvarchar ( 100 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	

	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
		Drop table #t

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t2' ) )
		Drop table #t2	
	
	Create table #t ( id int, Phone nvarchar ( 50 ) collate database_default )
	
	set @sql = '
		Select id2.Id, id2.Phone 
		From ' + @tableidx + ' id1 
			Inner join ' + @tableidxn + ' id2 on id1.Id = id2.Id
		Where IdOperator = ' + @operator + '
		'
	Insert into #t
		exec sp_executesql @sql



	declare @temp table ( IdInList int, AbonentNumber nvarchar ( 50 ) collate database_default, DTS DateTime  )

	Insert into @temp
		Select IdInList, AbonentNumber, Max ( DateTimeStart ) as DTS
		From #t t 
			inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.Id = ec.IdInList and t.Phone = ec.AbonentNumber
		Where IdTask = @taskid
		Group by IdInList, AbonentNumber


	Set @sql = 'Drop table ' + @tmptable
	if exists ( Select * FROM sysobjects where id = object_id ( @tmptable ) )
		exec sp_executesql @sql

	--Set @sql = 'Create table ' + @tmptable + ' ( Id int, '

	declare @ready table ( Id int )
	Insert into @ready
		Select IdInList
		From A_TaskManager_SubTasks
		Where TaskId = @taskid and NResult > 0

	--   .  ,     .  
	if exists ( Select id from @callstates Where Type = 3 )
	begin
		Delete From @callstates where Type = 0 or Type = 1
		Insert into @callstates values ( 0, 10 )
	end
		

	
	--     -    ,   
	Select t.IdInList, t.AbonentNumber, ec.DateTimeStart as __DateTimeStart, ec.CallResult as __CallResult, ec.UserResult as __UserResult, oi.[Name] as __Operator, case when ( st.NextEffortTime > stn.NextEffortTime ) then st.NextEffortTime else stn.NextEffortTime end as __NextCallTime into #t2
	From @temp t
		inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.IdInList = ec.IdInList and t.AbonentNumber = ec.AbonentNumber and t.DTS = ec.DateTimeStart
		inner join @callstates cs on ( ec.CallResult = cs.Id and cs.Type = 0 ) or ( ec.UserResult = cs.Id and cs.Type = 1 ) or ( cs.Type = 10 )
		
		inner join A_TaskManager_SubTaskNumber stn on t.IdInList = stn.IdInList and t.AbonentNumber = stn.Number and stn.TaskId = @taskid
		inner join A_TaskManager_SubTasks st on t.IdInList = st.IdInList and st.TaskId = @taskid
		Left join oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo oi on ec.IdOperator = oi.[Id]
	Where not exists ( Select * FROM @ready where Id = t.IdInList )

	Alter table #t2 Alter Column __DateTimeStart DateTime NULL
	Alter table #t2 Alter Column __CallResult Int NULL
	Alter table #t2 Alter Column __UserResult Int NULL
	Alter table #t2 Alter Column __Operator nvarchar ( 100 ) collate database_default NULL
	Alter table #t2 Alter Column __NextCallTime DateTime NULL

	Update #t2 set __NextCallTime = null where __NextCallTime < @dtnow

	-- (   ,     ),     ""  ""
	if exists ( Select id from @callstates Where Type = 2 or Type= 3 )
		Insert into #t2 ( IdInList, AbonentNumber )
		Select Id, Phone From #t t
			Where not exists ( Select IdInList From @temp where IdInList = t.Id and AbonentNumber = t.Phone )
				and not exists ( Select Id From @ready Where Id = t.Id )

	if ( Len ( @search ) > 0 )
	begin
		Set @sql = 'Select Count ( * ) From '
		if ( Len ( @table ) > 0 )
			Set @sql = @sql + @table + ' '
		else
			Set @sql = @sql + ' (' + @query + ') '
		Set @sql = @sql + ' t inner join #t2 t2 on t.Id = t2.IdInList Where ' + @search

		if exists ( Select * From tempdb..sysobjects where id = object_id ( 'tempdb..#t_smp' ) )
			drop table #t_smp

		create table #t_smp ( cnt int )
		Insert into #t_smp
			exec sp_executesql @sql

		Select @totalrowcount = cnt From #t_smp
	end
	else
		Select @totalrowcount = Count ( * ) From #t2

	declare @howmany int
	declare @topcnt int
	select @howmany = ( @partindex + 1 ) * @partcount - @totalrowcount, @topcnt = @partcount
	if ( @howmany > 0 )
		set @topcnt = @partcount - @howmany

	Set @sql = 'Select * From ( Select Top ' + Cast ( @topcnt as nvarchar ( 10 ) ) + ' * From ( '
	Set @sql = @sql + ' Select Top ' + Cast ( ( @partindex + 1 ) * @partcount as nvarchar ( 10 ) ) + ' t2.* ' + @cols + ' From '
	if ( Len ( @table ) > 0 )
		Set @sql = @sql + @table + ' '
	else
		Set @sql = @sql + ' (' + @query + ') '
	Set @sql = @sql + ' t inner join #t2 t2 on t.Id = t2.IdInList '
	if ( Len ( @search ) > 0 )
		Set @sql = @sql + 'Where ' + @search
	Set @sql = @sql + ' Order by IdInList ) tp Order By IdInList desc ) a Order by IdInList'

	exec sp_executesql @sql	

end
GO





if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardCallResults_Get' ) )
	Drop procedure dbo.A_TaskManager_CardCallResults_Get
GO

Create procedure dbo.A_TaskManager_CardCallResults_Get
as
begin
	Select [Id], [Name]
	From oktell_cc_temp.dbo.A_Cube_CC_Cat_TaskResultTypes
	Order by Id
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
	@taskid uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 50 ),
	@table nvarchar ( 100 ),
	@query nvarchar ( 1000 ) = '',
	@colphone nvarchar ( 100 ),
	@colid nvarchar ( 100 ),
	@checkcondition nvarchar ( 1000 )
as
begin
	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--         ,        . Sysobjects .
	--if exists ( Select * From sysobjects
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tt' ) )
		drop table #tt
	Create table #tt ( cnt int )

	Set @sql = 'Select Count ( * ) From '
	if ( Len ( @query ) > 0 )
		set @sql = @sql + ' ( ' + @query + ' ) t '
	else
		set @sql = @sql + @table + ' t '
	Set @sql = @sql + '		
		Where (' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ') and ( ' + @checkcondition + ' )'
	
	Insert into #tt
		Exec sp_executesql @sql	

	declare @cnt int
	Select @cnt = cnt from #tt

	if ( @cnt = 0 )
	begin
		Set @sql = 'SET ROWCOUNT 1

			Update ' + @table + '
			Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			SET ROWCOUNT 0'
	
		exec sp_executesql @sql

	
		set @sql = '
			if not exists ( select id from ' + @tableidxn + ' Where Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ' and phone = ''' + @number + ''')
				Insert into ' + @tableidxn + ' 
				Values ( ' + cast ( @idinlist as nvarchar ( 10 ) ) + ', ''' + @number + ''' )'
		if exists ( Select * FROM sysobjects where id = object_id ( @tableidxn ) )
			exec sp_executesql @sql

		select 1
	end
end
GO




if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_CallCenter_GetResourceOACrossInfo' ) )
	Drop procedure dbo.A_CallCenter_GetResourceOACrossInfo
GO

Create procedure dbo.A_CallCenter_GetResourceOACrossInfo
	@taskid uniqueidentifier,
	@states nvarchar ( 4000 ) = '',
	@dtnow datetime = null
as
begin

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	

	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec' ) )
		drop table #tec

	Select IdInList, Max ( DateTimeStart ) as DateTimeStart into #tec
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
	Where IdTask = @taskid
		And not IdOperator is null
	Group by IdInList

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec2' ) )
		drop table #tec2

	--  
	Select ec.IdOperator, ec.UserResult, Count ( * ) as cnt into #tec2
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Inner join #tec tec on tec.IdInlist = ec.IdInList and tec.DateTimeStart = ec.DateTimeStart
		Inner join @callstates cs on ( cs.Id = ec.UserResult ) and ( cs.Type = 1 )
	Where ec.Idtask = @taskid -- ,   ?
	Group by ec.IdOperator, ec.UserResult


	--       	
	declare @st int
	declare @tableidx nvarchar ( 100 )
		set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
		declare @sql nvarchar ( 4000 )

	--  
	if exists ( select * FROM @callstates Where Type = 2 ) 
	begin
		Select @st = Id From @callstates Where Type = 2

		if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec3' ) )
			drop table #tec3
		create table #tec3 ( IdOperator uniqueidentifier, UserResult int, cnt int )		
		
		Insert into #tec3
			Select IsNull ( ec.IdOperator, '00000000-0000-0000-0000-000000000000' ) as IdOperator, @st, Count ( * ) as cnt
			From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
				Inner join #tec tec on tec.IdInList = ec.IdInList and tec.DateTimeStart = ec.DateTimeStart
			Where not exists ( Select Id From @callstates where type = 1 and id = ec.UserResult )
			Group by ec.IdOperator
		
		set @sql = 'Select IdOperator, ' + cast ( @st as nvarchar ( 10 ) ) + ', Count ( distinct Id )
			From ' + @tableidx + ' t
			Where AC > 0 and 
				( not exists ( Select IdInList From #tec where IdInList = t.Id ) )
			Group By IdOperator
			'
		Insert into #tec3
			exec sp_executesql @sql

		Insert into #tec2
			Select IdOperator, UserResult, Sum ( cnt ) cnt
			From #tec3 
			Group By IdOperator, UserResult
	end
	

	-- 
	if exists ( select * FROM @callstates Where Type = 3 )
	begin
		Select @st = Id From @callstates Where Type = 3

		Set @sql = 'Select IsNull ( IdOperator, ''00000000-0000-0000-0000-000000000000'' ) as IdOperator, ' + cast ( @st as nvarchar ( 10 ) ) + ', Count ( distinct Id ) as cnt
			From ' + @tableidx + ' 
			Where AC = 0
			Group By IdOperator'
		Insert into #tec2
			exec sp_executesql @sql			
	end

	--  	
	Select IdOperator, UserResult, cnt From #tec2
end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_CallCenter_GetResourceOACrossInfo' ) )
	Drop procedure dbo.A_CallCenter_GetResourceOACrossInfo
GO

Create procedure dbo.A_CallCenter_GetResourceOACrossInfo
	@taskid uniqueidentifier,
	@states nvarchar ( 4000 ) = '',
	@isdistributed bit = 0,
	@dtnow datetime = null
as
begin

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	

	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec' ) )
		drop table #tec

	Select IdInList, Max ( DateTimeStart ) as DateTimeStart into #tec
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
	Where IdTask = @taskid
		And not IdOperator is null
	Group by IdInList


	if ( @isdistributed = 0 )
	begin
		--  IdOperator, UserResult, Count
		Select ec.IdOperator, ec.UserResult, Count ( * ) as cnt
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
			Inner join #tec tec on tec.IdInlist = ec.IdInList and tec.DateTimeStart = ec.DateTimeStart
			Inner join @callstates cs on ( cs.Id = ec.UserResult ) and ( cs.Type = 1 )
		Where ec.Idtask = @taskid -- ,   ?
		Group by ec.IdOperator, ec.UserResult
	end
	else
	begin
		if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec2' ) )
			drop table #tec2

		if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec3' ) )
			drop table #tec3

		Select ec.IdInList, ec.UserResult into #tec2
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
			Inner join #tec tec on tec.IdInlist = ec.IdInList and tec.DateTimeStart = ec.DateTimeStart


		--       	
		declare @st int
		declare @tableidx nvarchar ( 100 )
		set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
		declare @sql nvarchar ( 4000 )

	
		--  
		if exists ( select * FROM @callstates Where Type = 2 ) 
		begin
			Select @st = Id From @callstates Where Type = 2
	
			set @sql = 'Select Id, ' + cast ( @st as nvarchar ( 10 ) ) + '
				From ' + @tableidx + ' t
				Where AC > 0 and 
					( not exists ( Select IdInList From #tec where IdInList = t.Id ) )
				'
			Insert into #tec2
				exec sp_executesql @sql

			Update t2
			Set UserResult = @st
			From #tec2 t2
			Where not exists ( Select Id from @callstates Where type = 1 and Id = t2.UserResult )
		end
		else
			Delete From #tec2
			Where not exists ( Select Id from @callstates Where type = 1 and Id = #tec2.UserResult )			
	

		-- 
		if exists ( select * FROM @callstates Where Type = 3 )
		begin
			Select @st = Id From @callstates Where Type = 3

			Set @sql = 'Select Id, ' + cast ( @st as nvarchar ( 10 ) ) + '
				From ' + @tableidx + ' 
				Where AC = 0
				'
			Insert into #tec2
				exec sp_executesql @sql			
		end


		create table #tec3 ( IdOperator uniqueidentifier, UserResult int, cnt int )
		Set @sql = '
			Select IsNull ( IdOperator, ''00000000-0000-0000-0000-000000000000'' ) as IdOperator, UserResult, Count ( IdInList ) as cnt
			From #tec2 t2
				Inner join ' + @tableidx + ' t on t.Id = t2.IdInList
			Group By IdOperator, UserResult
			'

		--  IdOperator, UserResult, Count
		insert into #tec3
			exec sp_executesql @sql


		Select * 
		From #tec3

	end

end
GO



if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_GetTotalCount' ) )
	Drop procedure dbo.A_TaskManager_List_GetTotalCount
GO

Create procedure dbo.A_TaskManager_List_GetTotalCount
	@taskid uniqueidentifier,
	@table nvarchar ( 1000 ) = '',
	@query nvarchar ( 1000 ) = '',
	@colid nvarchar ( 100 )
as
begin
	declare @sql nvarchar ( 4000 )
	Set @sql = 'Select Count ( distinct ' + @colid + ' ) From '
	if ( len ( @query ) > 0 )
		Set @sql = @sql + ' ( ' + @query + ' ) t '
	else
		set @sql = @sql + @table + ' t '

	exec sp_executesql @sql
end
GO








if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_CallCenter_MoveResourceOACrossInfo' ) )
	Drop procedure dbo.A_CallCenter_MoveResourceOACrossInfo
GO

Create procedure dbo.A_CallCenter_MoveResourceOACrossInfo
	@taskid uniqueidentifier,
	@state nvarchar ( 100 ) = '',
	@states nvarchar ( 4000 ) = '',
	@srcoper uniqueidentifier,
	@destoper uniqueidentifier,
	@count int,
	@dtnow datetime = null
as
begin

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	
	
	select @st1 = @state
	select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
	set @j1 = charindex ( ':', @st1, 1 ) + 1
	select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )
	
	Declare @needstates table ( id int, type int )
	Insert into @needstates values ( @vs, @vt )
	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec' ) )
		drop table #tec

	Select IdInList, Max ( DateTimeStart ) as DateTimeStart into #tec
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
	Where IdTask = @taskid
		And not IdOperator is null
	Group by IdInList

	
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tec2' ) )
		drop table #tec2

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#topers' ) )
		drop table #topers

	Select ec.IdInList, ec.UserResult into #tec2
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Inner join #tec tec on tec.IdInlist = ec.IdInList and tec.DateTimeStart = ec.DateTimeStart


	--       	
	declare @st int
	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	declare @sql nvarchar ( 4000 )

	
	--  
	if exists ( select * FROM @callstates Where Type = 2 ) 
	begin
		Select @st = Id From @callstates Where Type = 2
	
		set @sql = 'Select Id, ' + cast ( @st as nvarchar ( 10 ) ) + '
			From ' + @tableidx + ' t
			Where AC > 0 and 
				( not exists ( Select IdInList From #tec where IdInList = t.Id ) )
			'
		Insert into #tec2
			exec sp_executesql @sql

		Update t2
		Set UserResult = @st
		From #tec2 t2
		Where not exists ( Select Id from @callstates Where type = 1 and Id = t2.UserResult )
	end
	else
		Delete From #tec2
		Where not exists ( Select Id from @callstates Where type = 1 and Id = #tec2.UserResult )			
	

	-- 
	if exists ( select * FROM @callstates Where Type = 3 )
	begin
		Select @st = Id From @callstates Where Type = 3

		Set @sql = 'Select Id, ' + cast ( @st as nvarchar ( 10 ) ) + '
			From ' + @tableidx + ' 
			Where AC = 0
			'
		Insert into #tec2
			exec sp_executesql @sql			
	end

	
	Create Table #topers ( IdOperator uniqueidentifier )
	Insert into #topers Values ( @srcoper )
	if ( @srcoper = '00000000-0000-0000-0000-000000000000' )
	begin
		Set @sql = '
			Select distinct IdOperator 
			From ' + @tableidx + ' t
			Where not exists ( Select IdOperator From A_TaskManager_Operators Where TaskId = ''' + Cast ( @taskid as nvarchar ( 100 ) ) + ''' and OperatorId = t.IdOperator )
			'
		Insert into #topers
		exec sp_executesql @sql
	end

		
	declare @destoperstr nvarchar ( 100 )
	set @destoperstr = '''' + Cast ( @destoper as nvarchar ( 100 ) ) + ''''
	if ( @destoper = '00000000-0000-0000-0000-000000000000' )
		set @destoperstr = 'NULL'

	Set @sql = '
		SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

		Update t
		Set IdOperator = ' + @destoperstr + '
		From ' + @tableidx + ' t, #tec2 t2, #topers o
		Where t.Id = t2.IdInList
			And t2.UserResult = ' + Cast ( @vs as nvarchar ( 50 ) ) + '
			And IsNull ( t.IdOperator, ''00000000-0000-0000-0000-000000000000'' ) = IsNull ( o.IdOperator, ''00000000-0000-0000-0000-000000000000'' )

		SET ROWCOUNT 0
		'
	
	exec sp_executesql @sql

end
GO




if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_List_DistrDirectDb_GetNumberHistory' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_GetNumberHistory
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_GetNumberHistory
	@taskid uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 50 )
as
begin
	Select * From
	(
		Select Top 300 IdChain, IdEffort, DateTimeStart, LenTime, CallResult, UserResult, CallResultInfo, IsRecorded, IdRecDir, ALineNum, BLineNum
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
		Where IdTask = @taskid		
			And IdInList = @idinlist
			And AbonentNumber = @number
		Order By DateTimeStart Desc
	)a
	Order By DateTimeStart
end
GO


if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_Task_ClearStatistics' ) )
	Drop procedure dbo.A_TaskManager_Task_ClearStatistics
GO

Create procedure dbo.A_TaskManager_Task_ClearStatistics
	@id uniqueidentifier,
	@clearcube bit
as
begin
	Delete 
	From dbo.A_TaskManager_SubTasks --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskEfforts --With ( TabLock )
	Where TaskId = @id

	Delete 
	From dbo.A_TaskManager_SubTaskNumber --With ( TabLock )
	Where TaskId = @id

	Update dbo.A_TaskManager_Tasks
	Set Done = 0
	Where Id = @id
	
	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
	Exec dbo.A_TaskManager_List_DistrDirectDB_CacheDelete @id

	if ( @clearcube = 1 )
	  Delete 
	  From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
	  Where IdTask = @id
end

GO