
if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_CallCenter_UserStateHistory' and TABLE_SCHEMA like 'dbo' )
if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_CallCenter_UserStateHistory' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'ICode' )
	Alter Table dbo.A_CallCenter_UserStateHistory
	Add ICode int default -1
GO

if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_CallCenter_UserStateChange' ) )
	drop procedure dbo.A_CallCenter_UserStateChange
GO

Create procedure dbo.[A_CallCenter_UserStateChange]
	@start bit,
	@idoperator uniqueidentifier,
	@state int,
	@info nvarchar ( 100 ) = '',
	@selfinfo bit = null,
	@icode int = -1,
	@dtnow datetime = null	
as
begin
	if ( @dtnow is null )
		set @dtnow = GetDate()

	Begin tran AAA

	update A_CallCenter_UserStateHistory with ( TabLock, HoldLock )
	Set TimeLeave = @dtnow,
		LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
	Where OperatorId = @idoperator 
		and State = @state
		and TimeLeave is null


	if ( @start > 0 )
	  begin
		if ( @state in ( 2, 3, 4 ) )
			update A_CallCenter_UserStateHistory -- with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow - TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and State in ( 2, 3, 4 )
				and TimeLeave is null

		Insert into A_CallCenter_UserStateHistory --with ( RowLock )
		Values ( NewId ( ), @idoperator, @state, @dtnow, null, null, @info, @selfinfo, @icode )

		if ( @state = 1 )
			Insert into A_CallCenter_UserStateHistory --with ( RowLock )
			Values ( NewId ( ), @idoperator, 2, @dtnow, null, null, '', 0, @icode )
	  end
	else
	  begin
		if ( @state = 0 )
			update A_CallCenter_UserStateHistory --with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
		else if ( @state = 1 )
			update A_CallCenter_UserStateHistory --with ( TabLock )
			Set 	TimeLeave = @dtnow,
				LengthSec = Cast ( (@dtnow- TimeEnter) as float ) * 86400
			Where OperatorId = @idoperator 
				and TimeLeave is null
				and State != 0
	  end

	Commit Tran AAA
end
GO


if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_UserStateInfoTypes' ) )
	drop table dbo.A_UserStateInfoTypes
GO

Create table dbo.A_UserStateInfoTypes
( 
  Id int not null primary key,
  Name nvarchar ( 100 ) not null
)
GO

Insert into dbo.A_UserStateInfoTypes Values ( 10101, '' )
Insert into dbo.A_UserStateInfoTypes Values ( 10102, '  ' )
Insert into dbo.A_UserStateInfoTypes Values ( 10103, '' )
Insert into dbo.A_UserStateInfoTypes Values ( 10104, '' )
Insert into dbo.A_UserStateInfoTypes Values ( 10105, '  ' )-- 

Insert into dbo.A_UserStateInfoTypes Values ( 10201, '' )
Insert into dbo.A_UserStateInfoTypes Values ( 10202, '' )
Insert into dbo.A_UserStateInfoTypes Values ( 10203, '  ' )
GO



if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_UserStateHistory' and TABLE_SCHEMA like 'dbo' )
if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_UserStateHistory' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'ICode' )
	Alter Table dbo.A_UserStateHistory
	Add ICode int default -1
GO

if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_UserState_GetInfo' ) )
	drop procedure dbo.A_UserState_GetInfo
GO

Create  Procedure dbo.A_UserState_GetInfo

	@userid				uniqueidentifier,
	@datestart			datetime,
	@datestop			datetime,
	@state				int
as

begin
	
	if ( @state < 0 )
		Select State, TimeChange, 
			case When ( icode is null or icode < 0  or icode = 1002) then Info When ( State = 2 ) then IsNull ( ls.Name, '' ) else IsNull ( it.Name, '' ) end Info, 
			UserSelfInfo 
		From A_UserStateHistory ush
			Left join A_TaskManager_CardLunchStates ls on ush.ICode = ls.Id
			Left join A_UserStateInfoTypes it on ush.icode = it.Id
		Where UserId = @userid 
			And TimeChange > @datestart and TimeChange < @dateStop 
		Order By TimeChange Desc
	else
		Select State, TimeChange, 
			case When ( icode is null or icode < 0  or icode = 1002) then Info When ( State = 2 ) then IsNull ( ls.Name, '' ) else IsNull ( it.Name, '' ) end Info, 
			UserSelfInfo 
		From A_UserStateHistory ush
			Left join A_TaskManager_CardLunchStates ls on ush.ICode = ls.Id
			Left join A_UserStateInfoTypes it on ush.icode = it.Id
		Where UserId = @userid 
			And TimeChange > @datestart and TimeChange < @dateStop 		
			And State = @state
		Order By TimeChange Desc
end
GO



if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_UserState_AddChange' ) )
	drop procedure dbo.A_UserState_AddChange
GO

Create   Procedure dbo.A_UserState_AddChange
	@id				uniqueidentifier,
	@userid				uniqueidentifier,
	@state				int,
	@time				datetime,
	@icode				int = -1,
	@info				nvarchar ( 500 ) = '',
	@userselfinfo			int = 0
as

begin

	Insert Into A_UserStateHistory
		( Id, UserId, State, TimeChange, Info, UserSelfInfo, ICode )
	Values 
		( @id, @userid, @state, @time, @info, @userselfinfo, @icode )
	
end
GO


if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ) )
	drop procedure dbo.A_DB_InitOnStart
GO


Create procedure [dbo].[A_DB_InitOnStart]
As
begin

		-----------------------------------------------------
		--    -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0, 10104 --''
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task -    
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		--        ,   
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set 	TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		--  
		-----------------------------------------------------

		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		-----------------------------------------------------
		--   ,  -    
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		--    
		-----------------------------------------------------

		Declare tcursor CURSOR FOR 
			Select name, Id  FROM sysobjects 
			Where type = 'U' and name like 'A_TaskManager_LocalList%'
		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )

		OPEN tcursor
		FETCH NEXT FROM tcursor INTO @llname, @llid

		WHILE @@FETCH_STATUS = 0
		BEGIN
			set @llname = 'dbo.[' + @llname + ']'

			--   (id    Id  ) (      -       . N-1  )	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			--      JoinedTable  
			if not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname )
			begin
				set @sql = ' DROP TABLE ' + @llname
				--print @sql
				exec sp_executesql @stmt =@sql
			end

		FETCH NEXT FROM tcursor INTO @llname, @llid
		END

		CLOSE tcursor
		DEALLOCATE tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		--   ??
		--         ?
		--     ?
		--   ..   ,     ..
		Exec A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
end
GO



if exists ( Select * From Sysobjects where id = object_id ( 'dbo.A_CallCenter_ControlEvents_GetJournal' ) )
	drop procedure dbo.A_CallCenter_ControlEvents_GetJournal
GO

Create procedure dbo.A_CallCenter_ControlEvents_GetJournal
	@iduser uniqueidentifier,
	@datestart datetime,
	@datestop datetime,
	@timestart datetime,
	@timestop datetime,
	@idsevent nvarchar ( 4000 ),
	@idstask nvarchar ( 4000 ),
	@idsoperator nvarchar ( 4000 )
as
begin
	Declare @dstart datetime, @tstart datetime, @dstop datetime, @tstop datetime
	Set @dstart = Cast ( Floor ( Cast ( @datestart as float ) ) as DateTime )
	Set @dstop = Cast ( Floor ( Cast ( @datestop as float ) + 1 ) as DateTime )
	Set @tstart = Cast ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) as DateTime )
	Set @tstop = Cast ( Cast ( @timestop as float ) - Floor ( Cast ( @timestop as float ) ) as DateTime )

	declare @temp nvarchar ( 4000 )
	declare @tempid uniqueidentifier

	Declare @events table ( id uniqueidentifier )
	Declare @tasks table ( id uniqueidentifier )
	Declare @operators table ( id uniqueidentifier )

	set @temp = @idsevent
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @events values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end	
	else
		Insert into @events
			Select Id 
			From A_CallCenter_ControlEvents
			Where IsDeleted = 0

	set @temp = @idstask
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @tasks values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end
	else
	   begin
		Insert into @tasks
			Select Id 
			From A_TaskManager_Tasks
		Insert into @tasks ( id ) values ( '00000000-0000-0000-0000-000000000000' )			
	   end


	set @temp = @idsoperator
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @operators values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end
	else
	   begin
		Insert into @operators
			Select Id 
			From A_Users
		Insert into @operators ( id ) values ( '00000000-0000-0000-0000-000000000000' )			
	   end
	

	Select j.Id, j.IdEvent, ce.Name as EventName, j.EventDateTime, j.ValStr, j.ValDec, j.IdTask, ti.Name as TaskName, j.IdOperator, oi.Name as OperatorName
	From A_CallCenter_ControlEventsJournal j
		Inner join A_CallCenter_ControlEvents ce on j.IdEvent = ce.Id
		Inner join @events e on j.IdEvent = e.Id
		Inner join @tasks t on j.IdTask = t.Id
		Inner join @operators o on j.IdOperator = o.Id
		Left join A_TaskManager_Tasks ti on ti.Id = t.Id
		Left join A_Users oi on oi.Id = o.Id
	Where ( EventDate between @dstart and @dstop )
		and ( EventTime > @tstart ) and ( EventTime < @tstop )
	
end
GO
