if exists ( Select * From sysobjects where id = object_id ( 'dbo.Report1_1' ))
	drop procedure dbo.Report1_1
GO

Create procedure dbo.Report1_1
	@d1 datetime,
	@d2 datetime,
	@t1 datetime,
	@t2 datetime,
	@intervalmin int = 30,
	@tasks nvarchar ( 100 ) = '',
	@operators nvarchar ( 100 ) = ''
as
begin

/*
	set dateformat dmy
	Declare @d1 datetime, @d2 datetime, @t1 datetime, @t2 datetime
	Select @d1 = '02.04.2008 0:00', @d2 = GetDate(), @t1 = '8:00', @t2 = '20:00'
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#tasks' ) )
		drop table #tasks
	Create table #tasks  ( id uniqueidentifier )
	Insert into #tasks
		Values ( 'CB3400A0-AB2B-46C2-B562-AC586AA5E444' )
		--Select Id from A_Taskmanager_Tasks
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#operators' ) )
		drop table #operators
	Create table #operators ( id uniqueidentifier )
	Insert into #operators
		Select Id From A_USers
	Declare @intervalmin int 
	set @intervalmin = 30
*/

	if ( @intervalmin is null )
		set @intervalmin = 1440

	--  
	declare @dstart datetime, @dstop datetime
	declare @tstart datetime, @tstop datetime
	set @dstart = Cast ( Floor ( cast ( @d1 as float ) ) as DateTime )
	set @dstop = Cast ( Floor ( cast ( @d2 as float ) + 1 ) as DateTime )
	set @tstart = Cast ( Cast ( @t1 as float ) - Floor ( cast ( @t1 as float ) ) as DateTime )
	set @tstop = Cast ( Cast ( @t2 as float ) - Floor ( cast ( @t2 as float ) ) as DateTime )

------------------------------------------------------------------------------------------------------
--   
	Declare @intervals table ( DTStart DateTime, DTStop DateTime, DStart DateTime, DStop DateTime, TStart DateTime, TStop DateTime )
	Declare @dt1 datetime, @dt2 datetime
	Declare @curday datetime, @curtime datetime
	Select @curday = @dstart, @curtime = @tstart
	while ( @curday < @dstop )
	   begin
		Set @dt1 = @curday + @curtime
		Set @dt2 = DateAdd ( mi, @intervalmin, @dt1 )

		Insert into @intervals
		Values ( @dt1, @dt2,
			Cast ( Floor ( cast ( @dt1 as float ) ) as DateTime ),
			Cast ( Floor ( cast ( @dt2 as float ) ) as DateTime ),
			Cast ( Cast ( @dt1 as float ) - Floor ( cast ( @dt1 as float ) ) as DateTime ),
			Cast ( Cast ( @dt2 as float ) - Floor ( cast ( @dt2 as float ) ) as DateTime ) )

		Set @curtime = DateAdd ( mi, @intervalmin, @curtime )
		if ( @curtime >= @tstop )
		begin
			set @curday = DateAdd ( d, 1, @curday )
			set @curtime = @tstart
		end

		if ( @curday >= @dstop )
			break;
	   end

------------------------------------------------------------------------------------------------------
--   
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
		drop table #t
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t2' ) )
		drop table #t2
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t3' ) )
		drop table #t3
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t4' ) )
		drop table #t4

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp0' ) )
		drop table #tmp0
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp1' ) )
		drop table #tmp1
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp2' ) )
		drop table #tmp2
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp3' ) )
		drop table #tmp3
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp4' ) )
		drop table #tmp4
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp5' ) )
		drop table #tmp5
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp6' ) )
		drop table #tmp6
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp7' ) )
		drop table #tmp7
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp8' ) )
		drop table #tmp8
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp9' ) )
		drop table #tmp9


	--      
	Select * Into #t
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
	Where DateStart between @dstart and @dstop
		and TimeStart between @tstart and @tstop

	Select ec.* Into #t2
	From #t ec
		Inner join #tasks t on ec.IdTask = t.Id
		Inner join #operators o on ec.IdOperator = o.Id

	Select os.* Into #t3
	From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os
		Inner join #operators o on os.IdOperator = o.Id
		Inner join #tasks t on os.IdTask = t.Id
	Where DateStart between @dstart and @dstop
		and TimeStart between @tstart and @tstop

	Select cq.* into #t4
	From oktell_cc_temp.dbo.A_Cube_CC_CallQueue cq
		Inner join #tasks t on cq.IdTask = t.Id
	Where DateStart between @dstart and @dstop
		and TimeStart between @tstart and @tstop


	--   
	Declare @output table ( DTStart DateTime, DTStop DateTime, TotalCntIncoming int, AvgQueue int, AvgTalk1 int, AvgTalk2 int, AvgPost int, CntLost int, AvgLostQueue int, CntLostParams int, CntNoAnswer int, CntFlashed int, AvgLenFlashed int )

	Insert Into @output ( DTStart, DTStop )
	Select DTStart, DTStop 
	From @intervals

------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------

--   .     
	Select i.DTStart, i.DTStop, Count ( * ) as TotalIncoming Into #tmp0
	From (
		Select IdChain, Min ( DateTimeStart ) DateTimeStart FROM #t2 ec			
		Where ec.IsOutput = 0
		Group by IdChain
		) ec
		Inner join @intervals i on ec.DateTimeStart between i.DTStart and i.DTStop
	Group By i.DTStart, i.DTStop
	Order By i.DTStart


	Update o
		Set TotalCntIncoming = tmp.TotalIncoming
	From @output o, #tmp0 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp0


------------------------------------------------------------------------------------------------------
--    .      IdEffort
	Select DTStart, DTStop, Avg ( LenQueue ) LenQueue into #tmp1
	From (
		Select DTStart, DTStop, IdChain, Sum ( LenQueue ) LenQueue
		From (
			Select i.DTStart, i.DTStop, IdChain, IdEffort, Min ( LenQueue ) LenQueue
			From #t2 ec
				inner join @intervals i on ec.DateTimeStart between i.DTStart and i.DTStop
			Group By IdChain, IdEffort, i.DTStart, i.DTStop
			) a
		Group By IdChain, DTStart, DTStop
		) b
	Group By DTStart, DTStop
	Order by DTStart

	Update o
		Set AvgQueue = tmp.LenQueue
	From @output o, #tmp1 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp1

------------------------------------------------------------------------------------------------------
--      
-- (    (timestart-timestop))
	Select i.DTStart, i.DTStop, Avg ( LenTalk1 ) LenTalk1 into #tmp2
	From (
		Select DTStart, DTStop, IdChain, IdEffort, cast ( DTStop - DTStart as float ) * 86400 as LenTalk1
		From (
			Select IdChain, IdEffort, Min ( DateTimeStart ) DTStart, Max ( DateTimeStop ) DTStop 
			From #t2 ec
			Group By IdChain, IdEffort
			)a 
		) b
			Inner join @intervals i on b.DTStart between i.DTStart and i.DTStop 
	Group by i.DTStart, i.DTStop


	Update o
		Set AvgTalk1 = tmp.LenTalk1
	From @output o, #tmp2 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp2

------------------------------------------------------------------------------------------------------
--      
-- (    (timeanswer-timestop))
	Select i.DTStart, i.DTStop, Avg ( LenTime ) LenTalk2 into #tmp3
	From (
		Select IdChain, IdEffort, IdOperator, Min ( DateTimeStart ) DTStart, Sum ( LenTime ) LenTime
		From #t2 ec
		Group By IdChain, IdEffort, IdOperator
		)a 
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
		Set AvgTalk2 = tmp.LenTalk2
	From @output o, #tmp3 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp3

------------------------------------------------------------------------------------------------------
--   
	Select i.DTStart, i.DTStop, Avg ( LenTime ) LenTime into #tmp4
	From #t3 os
		Inner join @intervals i on os.DateTimeStart between i.DTStart and i.DTStop 
	Where State = 7
	Group By i.DTStart, i.DTStop

	Update o
		Set AvgPost = tmp.LenTime
	From @output o, #tmp4 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp4

------------------------------------------------------------------------------------------------------
--    ().     (  )
--        ().     (  )
	declare @ids table ( id int )
	--Insert into @ids values ( 21 )
	--Insert into @ids values ( 22 )
	--Insert into @ids values ( 23 )
	--Insert into @ids values ( 24 )
	--Insert into @ids values ( 26 )
	--Insert into @ids values ( 27 )
	--Insert into @ids values ( 28 )
	--Insert into @ids values ( 19 )
	Insert into @ids values ( 13 )
	Insert into @ids values ( 7 )

	Select i.DTStart, i.DTStop, Count ( * ) Cnt, Avg ( LenQueue ) LenQueue into #tmp5
	From (
		Select IdEffort, IdChain, Min ( DateTimeStart ) DTStart, Max ( CallResult ) CallResult, Avg ( LenQueue ) LenQueue
		From #t ec
			Inner join #tasks t on ec.idTask = t.Id --  
		Group By IdEffort, IdChain
		)a
			Inner join @ids crs on a.CallResult = crs.Id
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
	Set 	CntLost = tmp.Cnt,
 		AvgLostQueue = tmp.LenQueue
	From @output o, #tmp5 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp5

------------------------------------------------------------------------------------------------------
--    ()       (  ,  ..)
	Delete From @ids
	Insert into @ids values ( 21 )
	Insert into @ids values ( 22 )
	Insert into @ids values ( 23 )
	Insert into @ids values ( 24 )
	Insert into @ids values ( 26 )
	Insert into @ids values ( 27 )
	Insert into @ids values ( 28 )
	--Insert into @ids values ( 19 )

	Select i.DTStart, i.DTStop, Count ( * ) Cnt into #tmp6
	From (
		Select IdEffort, IdChain, Min ( DateTimeStart ) DTStart, Max ( CallResult ) CallResult
		From #t ec
			Inner join #tasks t on ec.idTask = t.Id --  
		Group By IdEffort, IdChain
		)a
			Inner join @ids crs on a.CallResult = crs.Id
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
		Set CntLostParams = tmp.Cnt
	From @output o, #tmp6 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp6

------------------------------------------------------------------------------------------------------
--       (  - )
	Delete From @ids
	Insert into @ids values ( 6 )

	Select i.DTStart, i.DTStop, Count ( * ) Cnt into #tmp7
	From (
		Select IdEffort, IdChain, Min ( DateTimeStart ) DTStart, Max ( CallResult ) CallResult
		From #t ec
			Inner join #tasks t on ec.idTask = t.Id --  
		Group By IdEffort, IdChain
		)a
			Inner join @ids crs on a.CallResult = crs.Id
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
		Set CntNoAnswer = tmp.Cnt
	From @output o, #tmp7 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp7

------------------------------------------------------------------------------------------------------
--   (    > 1  )
--     (    > 1  )
	Select i.DTStart, i.DTStop, Count ( * ) Cnt, Avg ( LenTime1 ) LenTime1 into #tmp8
	From (
		Select IdEffort, IdChain, DTStart, DTStop, Cnt, cast ( DTStop - DTStart as float ) * 86400 LenTime1 From
		(
			Select IdEffort, IdChain, Min ( DTStart ) DTStart, Max ( DTStop ) DTStop, Count ( * ) Cnt
			From ( 
				Select IdEffort, IdChain, IdOperator, Min ( DateTimeStart ) DTStart, Max ( DateTimeStop ) DTStop
				From #t ec
					Inner join #tasks t on ec.idTask = t.Id --  
				Where exists ( Select Id From A_Users Where Id = ec.IdOperator )
				Group By IdEffort, IdChain, IdOperator
			)a		
			Group by IdEffort, IdChain
		)b
		Where Cnt > 1
	)c
		Inner join @intervals i on c.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
	Set 	CntFlashed = tmp.Cnt,
		AvgLenFlashed = tmp.LenTime1
	From @output o, #tmp8 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp8

------------------------------------------------------------------------------------------------------
--   ,  ,      .
/*
	Declare @cnt int
	Select @cnt = count ( * ) from #tasks
	if ( @cnt = 1 )
	begin
		Declare @idtask uniqueidentifier
		Select @idtask = Id From #tasks

		if exists ( Select * From tempdb..sysobjects where id = object_id ( 'tempdb..#cq' ) )
			drop table #cq

		Create table #cq ( id int identity ( 1, 1 ), DateTimeStart datetime, DateStart datetime, TimeStart datetime, CountQueue int, CountOperator int, CountTalking int )
		Insert into #cq (  DateTimeStart, DateStart, TimeStart, CountQueue, CountOperator, CountTalking )
			Select DateTimeStart, DateStart, TimeStart, CountQueue, CountOperator, CountTalking 
			From #t4 
			Where IdTask = @idtask
			Order by DateTimeStart

		Declare @cq table ( id1 int, id2 int, dt1 DateTime, dt2 DateTime, lenper float, cq int, co int, ct int )
		Insert into @cq ( id1, id2, dt1, dt2, lenper, cq, co, ct )
			Select cq1.Id, cq2.Id, cq1.DateTimeStart, cq2.DateTimeStart, Cast ( cq2.DateTimeStart - cq1.DateTimeStart as float ) LenPeriod, cq1.CountQueue, cq1.CountOperator, cq1.CountTalking 
			From #cq cq1
				Inner join #cq cq2 on cq1.Id + 1 = cq2.Id

		Select i.DTStart, i.DTStop, Sum ( cq * lenper ) / Sum ( lenper ) AvgCQ, Sum ( co * lenper ) / Sum ( lenper ) AvgCO, Sum ( ct * lenper ) / Sum ( lenper ) AvgCT into #tmp9
		From @cq
			Inner join @intervals i on dt1 between i.DTStart and i.DTStop
		Group By i.DTStart, i.DTStop

	
		Update o
		Set 	CntFlashed = tmp.Cnt,
			AvgLenFlashed = tmp.LenTime1
		From @output o, #tmp9 tmp
		Where o.DTStart = tmp.DTStart

		Drop table #tmp9
	end
*/
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------

	--  NULL  
	Update @output 
	Set TotalCntIncoming = 0
	Where TotalCntIncoming is null

	Update @output 
	Set AvgQueue = 0
	Where AvgQueue is null

	Update @output 
	Set AvgTalk1 = 0
	Where AvgTalk1 is null

	Update @output 
	Set AvgTalk2 = 0
	Where AvgTalk2 is null

	Update @output 
	Set AvgPost = 0
	Where AvgPost is null

	Update @output 
	Set CntLost = 0
	Where CntLost is null

	Update @output 
	Set AvgLostQueue = 0
	Where AvgLostQueue is null

	Update @output 
	Set CntLostParams = 0
	Where CntLostParams is null

	Update @output 
	Set CntNoAnswer = 0
	Where CntNoAnswer is null

	Update @output 
	Set CntFlashed = 0
	Where CntFlashed is null

	Update @output 
	Set AvgLenFlashed = 0
	Where AvgLenFlashed is null


	-- 
	Select * FROM @output
end
GO