if exists ( Select * from Sysobjects where id = object_id ( 'dbo.A_ServerSipLines' ) )
	Drop table [dbo].[A_ServerSipLines]
GO

CREATE TABLE [dbo].[A_ServerSipLines] (
	[ID] [uniqueidentifier] NOT NULL Primary Key,
	[Type] [int] NULL ,
	[ServerID] [uniqueidentifier] NULL ,
	[SystemNum] [int] NULL ,
	[Enabled] [bit] NULL ,
	[Caption] [nvarchar] (50) COLLATE Cyrillic_General_CI_AS NULL ,
	[CityStraight] [bit] NULL ,
	[ParentGroupId] [uniqueidentifier] NULL ,
	[DefaultUserId] [uniqueidentifier] NULL ,
	[Address] [nvarchar] (500) COLLATE Cyrillic_General_CI_AS NULL ,
) ON [PRIMARY]
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_View_ServerIntLinesAll' ) )
	drop view dbo.A_View_ServerIntLinesAll
GO
 
Create View [dbo].[A_View_ServerIntLinesAll]
as
--    
	Select Id, Caption, SystemNum, Enabled
	From ( 
		Select Id, Caption, SystemNum, Enabled From A_ServerIntLines

		Union

		Select Id, Caption, SystemNum, Enabled From A_ServerUsbLines

		Union

		Select Id, Caption, SystemNum, Enabled From A_ServerSipLines
	)a	
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_View_LineStates' ) )
	drop view dbo.A_View_LineStates
GO

Create View dbo.A_View_LineStates
AS
--   
	Select Id, Enabled, Type, OwnerId, React, ServerId, ReactServer, Caption, Connected, SystemNum
	From ( 
		SELECT a.ID, a.Enabled, a.type, a.OwnerID, WP1.ID AS react, 
			case WP1.type when 5 then WP1.ID else WP1.parentID end as ServerID , 
			WP1.Type AS reactserver, a.caption, 0 as connected, SystemNum
		FROM ( 	SELECT ID, Enabled, type, ServerID as OwnerId, caption, SystemNum
        	       	FROM A_ServerExtLines el
               		UNION ALL
	               	SELECT id, enabled, type, serverID,  caption, SystemNum
        	       	FROM A_ServerIntLines il
               		UNION ALL
		 	SELECT id, enabled, type, serverID,  caption, SystemNum
        	       	FROM A_ServerSipLines ipl
               		UNION ALL
	               	SELECT id, enabled, type, serverID, caption, SystemNum
        	       	FROM A_ServerGSMLines gl
               		UNION ALL
	               	SELECT id, enabled, type, serverID,  caption, SystemNum
        	       	FROM A_ServerUSBLines ul
		) a 	
			INNER JOIN  dbo.A_LinesReactors LR ON a.ID = LR.LineID 
			INNER JOIN  dbo.A_WorkPlaces WP1 ON LR.WPID = WP1.ID
		UNION
	
		SELECT a.ID, a.Enabled, a.type, a.OwnerID, null AS react,  
			a.OwnerId as ServerID , null AS reactserver, a.caption, 1 as connected, SystemNum
		FROM ( SELECT ID, Enabled, type, ServerID as OwnerId,  caption, SystemNum
	               FROM A_ServerExtLines el
        	       UNION ALL
	               SELECT id, enabled, type, serverID,  caption, SystemNum
        	       FROM A_ServerIntLines il
	               UNION ALL
        	       SELECT id, enabled, type, serverID,  caption, SystemNum
	               FROM A_ServerSipLines ipl
        	       UNION ALL
	               SELECT id, enabled, type, serverID, caption, SystemNum
        	       FROM A_ServerGSMLines gl
	               UNION ALL
        	       SELECT id, enabled, type, serverID,  caption, SystemNum
	               FROM A_ServerUSBLines ul
		) a 
		Where not a.ID in ( Select LineID from A_LinesReactors )
	)b	
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Line_GetLineStates' ) )
	drop procedure dbo.A_Line_GetLineStates
GO

Create Procedure dbo.A_Line_GetLineStates
as
begin
	Select ID, Enabled, Type, OwnerID, React, ServerID, reactserver, connected, SystemNum 
	From A_View_LineStates 
	Order By SystemNum
end
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_Line_Int_Set' ) )
	drop procedure dbo.A_Admin_Line_Int_Set
GO

CREATE  Procedure [dbo].A_Admin_Line_Int_Set
	@id			uniqueidentifier,
	@citystraight		bit,
	@caption		nvarchar ( 50 ),
	@enabled		bit,
	@parentgroupid		uniqueidentifier

as
begin
--     
	Update A_ServerIntLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid
	Where	Id = @id

	Update A_ServerUsbLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid
	Where	Id = @id
		
	Update A_ServerSipLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid
	Where	Id = @id
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Int_Get' ) )
	drop procedure dbo.A_Admin_Lines_Int_Get
GO

CREATE Procedure [dbo].A_Admin_Lines_Int_Get
	@id	uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address
	
	FROM 
	(	
		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address
		From A_ServerIntLines

		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address
		From A_ServerSipLines
	) e
	
	Inner join A_WorkPlaces w on e.ServerID = w.ID
	Inner join @groups g on e.ParentGroupId = g.GroupId
	Order By SystemNum
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address
		From A_ServerIntLines
		
	) e
	
	Inner join A_WorkPlaces w on e.ServerID = w.ID
	Inner join @groups g on e.ParentGroupId = g.GroupId
	Where e.ServerId = @id
	Order By SystemNum
    end	

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_WorkPlace_GetDefaultUsers' ) )
	drop procedure dbo.A_WorkPlace_GetDefaultUsers
GO

CREATE 	procedure [dbo].[A_WorkPlace_GetDefaultUsers]
as
begin
	Select Id, DefaultUserId From A_ServerIntLines

	Union

	Select Id, DefaultUserId From A_ServerSipLines
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserGroup_Group_SiftEmpty' ) )
	drop procedure dbo.A_Admin_UserGroup_Group_SiftEmpty
GO

CREATE 	procedure [dbo].[A_Admin_UserGroup_Group_SiftEmpty]
as
begin
--   

	--   
	declare @gc table ( nm nvarchar ( 255 ) collate database_default, cnt int )
	Insert into @gc 
		Select [Name], Count ( * ) as cnt 
		From A_Groups
		Group By [Name]

	declare @cnt int	
	Select @cnt = Count ( * )
	From @gc 
	Where cnt > 1

		
	if ( @@rowcount > 0 )
	begin
	   declare @change table ( id uniqueidentifier, idto uniqueidentifier )
	   declare @id uniqueidentifier
           declare @name nvarchar ( 255 )

	   declare @lastid uniqueidentifier	
	   declare @lastname nvarchar ( 255 )
	   set @lastname = ''

	   declare cs Cursor For
		Select id, name 
		From A_Groups
			inner join @gc gc on [name] like gc.nm
		Where gc.cnt > 1
		Order By name
	  

	   Open cs
	   Fetch Next From cs Into @id, @name
	   While ( @@FETCH_STATUS = 0 )
	   Begin
		if ( @name = @lastname )
                    begin
			Insert Into @change ( id, idto )
				Values ( @id, @lastid )
		    end
		else
		    begin
			set @lastid = @id
			set @lastname = @name
		    end
			
	   	Fetch Next From cs Into @id, @name
	   End
	   Close cs
	   Deallocate cs

	   --Select * FROM @change

	Update A_ServerUsbLines
    	Set ParentGroupId = ch.idto
	From A_ServerUsbLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerIntLines
    	Set ParentGroupId = ch.idto
	From A_ServerIntLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_ServerSipLines
    	Set ParentGroupId = ch.idto
	From A_ServerSipLines u, @change ch
	Where u.ParentGroupId = ch.Id

	Update A_Users
    	Set ParentGroupId = ch.idto
	From A_Users u, @change ch
	Where u.ParentGroupId = ch.Id


	end

	
	Delete 
	From A_Groups 
	Where not ID in ( Select ParentGroupID From A_Users 
				union
			  Select ParentGroupId From A_ServerUsbLines 
				union 
			  Select ParentGroupId From A_ServerIntLines )

end
GO




if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_Extra_SaveRestoreAdmin' ) )
	drop procedure dbo.A_DB_Extra_SaveRestoreAdmin
GO

CREATE  Procedure [dbo].A_DB_Extra_SaveRestoreAdmin
as

begin
--       

exec dbo.A_DB_FREEALL

Insert Into A_Users 
	Select * From A_users 
Insert Into A_WorkPlaces
	Select * From A_workplaces 
Insert Into A_Groups
	Select * From A_groups 
Insert Into A_NumberPlan
	Select * From A_numberplan 
Insert Into A_NumberPlanAction
	Select * From A_numberplanaction
Insert Into A_Rules
	Select * From A_rules 
Insert Into A_RuleRecords
	Select * From A_rulerecords 
Insert Into A_Settings
	Select * From A_settings 
Insert Into A_WorkPlace_Address
	Select * From A_workplace_address
Insert Into A_ServerUSBLines
	Select * From A_serverusblines 
Insert Into A_ServerIntLines
	Select * From A_serverintlines 
Insert Into A_ServerSipLines
	Select * From A_ServerSipLines 
Insert Into A_ServerExtLines
	Select * From A_serverextlines 
Insert Into A_ServerNumbers
	Select * From A_servernumbers
Insert Into A_ActualBase
	Select * From A_actualbase

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_FreeAll' ) )
	drop procedure dbo.A_DB_FreeAll
GO

CREATE PROCEDURE [dbo].[A_DB_FreeAll] AS
begin
--     
	Delete from dbo.A__Extra_OneLine_Settings
	Delete from dbo.A_ActualBase
	Delete from dbo.A_CallBackOrders
	Delete from dbo.A_CallBackRecievers
	Delete from dbo.A_CallCenter_Counters
	Delete from dbo.A_CallCenter_UserStateHistory
	Delete from dbo.A_ClientContacts
	Delete from dbo.A_ClientContactTypes
	Delete from dbo.A_ClientGroups
	Delete from dbo.A_ClientHistory
	Delete from dbo.A_Clients
	Delete from dbo.A_Clients_Groups
	Delete from dbo.A_ExtNumbers
	Delete from dbo.A_Groups
	Delete from dbo.A_LineCodes
	Delete from dbo.A_LinesReactors
	Delete from dbo.A_MobileControlMaskDenied
	Delete from dbo.A_MobileControlMaskFree
	Delete from dbo.A_Monopoly
	Delete from dbo.A_NumberPlan
	Delete from dbo.A_NumberPlanAction
	Delete from dbo.A_Personal_ListInfo
	Delete from dbo.A_Redirect
	Delete from dbo.A_Redirect_Abonents
	Delete from dbo.A_Redirect_TimeTable
	Delete from dbo.A_Rules
	Delete from dbo.A_RuleRecords
	Delete from dbo.A_ServerExtLines
	Delete from dbo.A_ServerGSMLines
	Delete from dbo.A_ServerIntLines
	Delete from dbo.A_ServerSipLines
	Delete from dbo.A_ServerNumbers
	Delete from dbo.A_ServerUSBLines
	Delete from dbo.A_Settings
	Delete from dbo.A_Streams
	Delete from dbo.A_User_NotifyLog
	Delete from dbo.A_UserControlLines
	Delete from dbo.A_UserControls
	Delete from dbo.A_UserOutcomingLines
	Delete from dbo.A_UserRoles
	Delete from dbo.A_UserRolesExt
	Delete from dbo.A_Users
	Delete from dbo.A_UserStateHistory
	Delete from dbo.A_VoiceMail
	Delete from dbo.A_WorkPlace_Address
	Delete from dbo.A_WorkPlaces

	Delete from dbo.A_TaskManager_Lists
	Delete from dbo.A_TaskManager_Operators
	Delete from dbo.A_TaskManager_Projects
	Delete from dbo.A_TaskManager_RunPeriods
	Delete from dbo.A_TaskManager_SubTaskEfforts
	Delete from dbo.A_TaskManager_SubTaskNumber
	Delete from dbo.A_TaskManager_SubTasks
	Delete from dbo.A_TaskManager_Task_IncomingCalls
	Delete from dbo.A_TaskManager_TaskAuto_List
	Delete from dbo.A_TaskManager_TaskExtLines
	Delete from dbo.A_TaskManager_Tasks
	Delete from dbo.A_TaskManager_TaskSupervisors
	Delete from dbo.A_TaskManager_UserInTask

	Delete from dbo.A_Stat_Connections_1x1
	Delete from dbo.A_Stat_Talk_Algorythms
	Delete from dbo.A_Stat_Talk_Card_Check
	Delete from dbo.A_Stat_Talk_Card_Radio
	Delete from dbo.A_Stat_Talk_Card_Text
	Delete from dbo.A_Stat_Talk_StopInfo
	
	Delete from dbo.C_GroupOperators
	Delete from dbo.C_Groups
	Delete from dbo.C_MonopolyForTaskChanging
	Delete from dbo.C_OperatorControlEvents
	Delete from dbo.C_OperatorTimeTable
	Delete from dbo.C_TaskControlEvents
	
	Delete from dbo.P_ListView
	Delete from dbo.T_LastCallPhoneNumber
	

	---------------------------------------------
	---   ------------------------
	---------------------------------------------
	DECLARE tcursor CURSOR FOR 
		Select name  FROM sysobjects 
		Where type = 'U' and name like 'A_TaskManager_LocalList%'
	declare @llname nvarchar ( 1000 )
	declare @sql nvarchar ( 500 )

	OPEN tcursor
	FETCH NEXT FROM tcursor INTO @llname

	WHILE @@FETCH_STATUS = 0
	BEGIN
		set @llname = 'dbo.[' + @llname + ']'
		set @sql = ' DROP TABLE ' + @llname
		exec sp_executesql @stmt =@sql
	
		FETCH NEXT FROM tcursor INTO @llname
	END

	CLOSE tcursor
	DEALLOCATE tcursor
	---------------------------------------------
	---------------------------------------------

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ) )
	drop procedure dbo.A_DB_RemoveTails
GO


Create procedure [dbo].[A_DB_RemoveTails] as
begin
--      .  ,    ..
		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not ( LineId in ( Select [ID] From A_ServerIntLines 
											union all 
											Select ID From A_ServerUSBLines
											union all
											Select ID From A_ServerSipLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerSipLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines
								union Select [ID] from A_ServerSipLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines union
			Select [id] from A_ServerSipLines 

		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id from A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId
			From A_ServerIntLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'
			Union
			Select Id, DefaultUserId
			From A_ServerSipLines
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 from @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id from A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id from C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id from @uidt)
			or not UserB in (Select id from @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--   ------------------------------------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------
		Delete From A_UserRoles 
		Where creationtype != 0 
			and not exists ( Select IdRole FROM A_UserParams up Where up.IdRole = A_UserRoles.Id )
		Delete From A_UserRolesExt 
		Where not exists ( Select Id From A_UserRoles a where a.Id = IdRole )

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Line_GetIdByNum' ) )
	drop procedure dbo.A_Line_GetIdByNum
GO

Create Procedure [dbo].[A_Line_GetIdByNum] 	
	@num 		nvarchar ( 10 )	
AS
Begin
--      

	Select Id 
	From ( 
		Select Id, SystemNum
		From A_ServerIntLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerUSBLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerSipLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerExtLines
	) a
	Where SystemNum = cast(@num as int)
	
END
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Line_GetNumById' ) )
	drop procedure dbo.A_Line_GetNumById
GO

Create Procedure[dbo].[A_Line_GetNumById] 
	@id uniqueidentifier	
As
Begin
--      

	Select cast ( SystemNum as nvarchar ( 10 ) ) as SystemNum
	From ( 
		Select Id, SystemNum
		From A_ServerIntLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerUSBLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerSipLines
	
		Union All
	
		Select Id, SystemNum
		From A_ServerExtLines
	) a
	Where [Id] = @id
END
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Lines_Numbers_Get' ) )
	drop procedure dbo.A_Lines_Numbers_Get
GO

Create procedure [dbo].A_Lines_Numbers_Get
as
begin
--       
	Select Id, SystemNum
	From ( 
		Select Id, SystemNum From A_ServerUSBLines
		Union All
		Select Id, SystemNum From A_ServerExtLines
		Union All
		Select Id, SystemNum From A_ServerIntLines
		Union All
		Select Id, SystemNum From A_ServerSipLines
		Union All
		Select Id, SystemNum From A_ServerGSMLines
	) a
	Order By SystemNum
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_MobileControl_Journal_Get' ) )
	drop procedure dbo.A_MobileControl_Journal_Get
GO

CREATE  procedure [dbo].[A_MobileControl_Journal_Get]
	@dstart 	datetime,
 	@dstop 		datetime,
 	@tstart 	datetime,
 	@tstop 		datetime,
	@number		nvarchar ( 50 ),
	@userid		uniqueidentifier
as
begin
--     

---   ---------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare @number nvarchar ( 50 )
declare @userid uniqueidentifier


set @dstart = '2006/06/01'
set @dstop = '2006/07/19'
set @tstart = '10:11:00'
set @tstop = '12:20:00'
set @number = ''
set @userid = '00000000-0000-0000-0000-000000000000'
*/

---------------------------------

	Declare @tstartfloat float 
	Declare @tstopfloat float
	Set @tstartfloat = Convert ( float, @tstart )
	Set @tstopfloat  = Convert ( float, @tstop )
	Set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
	Set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


	--   
	Declare @chains table ( IdChain uniqueidentifier, TimeStop DateTime )
	if ( @number = '' )
		Insert into @chains
			Select IdChain, Max ( TimeStop ) as TimeStop
			From A_Stat_Connections_1x1 sc
			Where TimeStop > @dstart and TimeStart < @dstop
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
				--and BOutNumber like '%' + @number + '%'
			Group By IdChain
	else
		Insert into @chains
			Select IdChain, Max ( TimeStop ) as TimeStop
			From A_Stat_Connections_1x1 sc
			Where TimeStop > @dstart and TimeStart < @dstop
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
				and BOutNumber like '%' + @number + '%'
			Group By IdChain

	Declare @united table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
	Insert Into @united
		Select Id, Name From A_Users
		Union
		Select Id, ( Cast ( SystemNum as nvarchar ( 10 ) ) + ' ' + Caption ) as Name From A_ServerIntLines
		Union
		Select Id, ( Cast ( SystemNum as nvarchar ( 10 ) ) + ' ' + Caption ) as Name From A_ServerSipLines

	Select sc.Id as connectionid, sc.TimeStart, u.Name as username, u.Id as userid, mcd.mask, mcd.Description, sc.BOutNumber, case When mcf.mask is null then 1 else 0 end as denied, CAST ( CAST ( ch.TimeStop - sc.TimeStart as DateTime ) as float ) as Length, sc.IsRecorded, sc.IdRecDir, sc.ALineNum, sc.BLineNum--, sc.ARecFile, sc.BRecFile 
	From A_Stat_Connections_1x1 sc
		inner join A_MobileControlMaskDenied mcd on sc.BOutNumber like REPLACE ( mcd.mask, '?', '_' )
		inner join @united u on sc.AUserId = u.Id or sc.ALineId = u.Id
		inner join @chains ch on sc.IdChain = ch.IdChain
		Left Join A_MobileControlMaskFree mcf on sc.BOutNumber like REPLACE ( mcf.mask, '?', '_' )
	Where ( u.Id = @userid or @userid = '00000000-0000-0000-0000-000000000000' )
	Order By sc.TimeStart

End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Personal_GetNumbersDepartmentInfo' ) )
	drop procedure dbo.A_Personal_GetNumbersDepartmentInfo
GO

CREATE  Procedure [dbo].[A_Personal_GetNumbersDepartmentInfo]
As
Begin
--      

	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner join A_NumberPlanAction na on na.NumId = np.Id
			Inner join A_Rules r on na.ExtraId = r.Id
			Inner join A_RuleRecords rr on rr.RuleId = r.Id


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', ' ' )


	Declare @cnt int
	Set @cnt = 0


	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--    @cnt - 
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner join @t t1 on t.Reactid = t1.nId
			Where t.ReactId != t.Nid
	
		--    
		Delete 	From @t
			From @temp
		Where nid = id and reactid = oldrid

		-- 
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		-- 
		Delete From @temp	
	end

	--Select @cnt

	--    
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id

	--Select @@rowcount

	Declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert Into @output
		Select nid, Prefix, groupid, groupname FROM 
		(
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_Users u on t.ReactId = u.Id
				Inner join @groups g on u.ParentGroupId = g.GroupId
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_ServerIntLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_ServerUsbLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName
			From @t t
				Inner join A_ServerSipLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		) a
		Group By Prefix, GroupId, nid, groupname


	Declare @og table ( id uniqueidentifier, cnt int )
	Insert into @og
		Select * From
		(
			Select nid, count ( * ) as cnt
			From @output
			Group By nid
		)a

	Update @output 
	Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
	From @output o, @og og
	Where o.nid = og.id and og.cnt > 1

	Select nid, prefix, groupid, groupname 
	From @output
	Group By nid, prefix, groupid, groupname

End
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Personal_NumbersInfo_Get' ) )
	drop procedure dbo.A_Personal_NumbersInfo_Get
GO

CREATE   Procedure [dbo].[A_Personal_NumbersInfo_Get]
As
Begin
--     
	
	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner join A_NumberPlanAction na on na.NumId = np.Id
			Inner join A_Rules r on na.ExtraId = r.Id
			Inner join A_RuleRecords rr on rr.RuleId = r.Id


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', ' ' )


	Declare @cnt int
	Set @cnt = 0


	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--    @cnt - 
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner join @t t1 on t.Reactid = t1.nId
			Where t.ReactId != t.Nid
	
		--    
		Delete From @t
			From @temp
		Where nid = id and reactid = oldrid

		-- 
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		-- 
		Delete From @temp	
	end

	--Select @cnt

	--    
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id

	--Select @@rowcount

	Declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default, isline bit )
	Insert Into @output
		Select nid, Prefix, GroupId, GroupName, min ( IsLine ) as IsLine FROM 
		(
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as IsLine
			From @t t
				Inner join A_Users u on t.ReactId = u.Id
				Inner join @groups g on u.ParentGroupId = g.GroupId
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
			From @t t
				Inner join A_ServerIntLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
			From @t t
				Inner join A_ServerUsbLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
			union all
			Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as IsLine
			From @t t
				Inner join A_ServerSipLines l on t.ReactId = l.Id
				Inner join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
		) a
		Group By Prefix, GroupId, nid, groupname


	Declare @og table ( id uniqueidentifier, cnt int )
	Insert into @og
		Select * From
		(
			Select nid, count ( * ) as cnt
			From @output
			Group By nid
		)a

	Update @output 
	Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = ' '
	From @output o, @og og
	Where o.nid = og.id and og.cnt > 1

	Select nid, prefix, groupid, groupname, isline
	From @output
	Group By nid, prefix, groupid, groupname, isline

End
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Personal_NumbersInfo_GetSeparate' ) )
	drop procedure dbo.A_Personal_NumbersInfo_GetSeparate
GO

CREATE      Procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
As
Begin
--       
	
	Declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, reactid uniqueidentifier )
	Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, oldrid uniqueidentifier, newrid uniqueidentifier )

	Insert Into @t
		Select np.Id, np.Prefix, rr.ReactId
		From A_NumberPlan np
			Inner join A_NumberPlanAction na on na.NumId = np.Id
			Inner join A_Rules r on na.ExtraId = r.Id
			Inner join A_RuleRecords rr on rr.RuleId = r.Id


	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', ' ' )


	Declare @cnt int
	Set @cnt = 0


	While ( @@rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--    @cnt - 
		Insert Into @temp
			Select t.nid, t.prefix, t.reactid, t1.reactid
			From @t t
				Inner join @t t1 on t.Reactid = t1.nId
			Where t.ReactId != t.Nid
	
		--    
		Delete From @t
			From @temp
		Where nid = id and reactid = oldrid

		-- 
		Insert Into @t ( nid, prefix, reactid )
			Select id, prefix, newrid From @temp

		-- 
		Delete From @temp	
	end

	--Select @cnt

	--    
	Delete From @t
		From A_NumberPlan np
	Where reactid = np.Id

	
	
	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as ReactType
	From @t t
		Inner join A_Users u on t.ReactId = u.Id
		Inner join @groups g on u.ParentGroupId = g.GroupId
	union all
	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as ReactType
	From @t t
		Inner join A_ServerIntLines l on t.ReactId = l.Id
		Inner join @groups g on l.ParentGroupId = g.GroupId
	union all
	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 2 as ReactType
	From @t t
		Inner join A_ServerUsbLines l on t.ReactId = l.Id
		Inner join @groups g on l.ParentGroupId = g.GroupId
	union all
	Select t.nId, t.Prefix, t.ReactId, g.GroupId, g.GroupName, 3 as ReactType
	From @t t
		Inner join A_ServerSipLines l on t.ReactId = l.Id
		Inner join @groups g on l.ParentGroupId = g.GroupId

End
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_AllCalls' ) )
	drop procedure dbo.A_Stat_Office_Diagramm_AllCalls
GO

CREATE   procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int
as

begin
-- .  " "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 4
--------------------------------------------------------------------
*/
		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype

	
	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain

			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )							
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			declare @lines2 table ( lineid uniqueidentifier )
			insert into @lines2
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
				union 
				Select ID from A_ServerSipLines
	

			Select uid, sum ( count_ ) count_ from
			(
				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.AUserId
				Group by AUserId
			
				union all
			
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join A_Users u on u.Id = ts.BUserId
				Group By BUserId

				union

				select AUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.BLineId
				Where ( ALineNum like 'IVR' )
				Group by AUserId

				union all
					
				select BUserId as uid, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines2 l on l.lineid = ts.ALineId
				Where ( BLineNum like 'IVR' )
				Group By BUserId
	
			)a
			group by uid
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines
				union 
				Select ID from A_ServerSipLines


			Select linenum, sum ( count_ ) count_ from
			(
				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId	
				Group by ALineNum
			
				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				Group By BLineNum

				union all

				select ALineNum as linenum, count ( * ) as count_
				from #tempstatistics ts 
					inner join @lines3 l on l.lineid = ts.BLineId
				where ALineNum like 'IVR' 
				Group by ALineNum

				union all

				select BLineNum as linenum, count ( * ) as count_
				from #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
				where BLineNum like 'IVR'
				Group by BLineNum
			)a
			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

		declare @lines4 table ( lineid uniqueidentifier )
		insert into @lines4
			Select ID from A_ServerIntLines
			union 
			Select ID from A_ServerUSBLines
			union 
			Select ID from A_ServerSipLines

		Select prefix, sum ( count_ ) count_ from
		(
			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = AUserId
			Group by prefix

			union all

			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				inner join A_Users u on u.id = BUserId
			Group by prefix

			union all

			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = ALineId
			Group by prefix

			union all
		
			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				inner join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
				inner join @lines4 l on l.lineid = BLineId
			Group by prefix
		)a
		Group by prefix
	end	

	delete from #tempstatistics

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_AverageCallTime' ) )
	drop procedure dbo.A_Stat_Office_Diagramm_AverageCallTime
GO

CREATE   procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int
as

begin
-- .  "  "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdateInt') )
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdateInt

			insert into #tempstatisticsYMDdateInt
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, Count ( * ) as count_
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDdateInt

			delete from #tempstatisticsYMDdateInt										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdateInt') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDHdateInt
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdateInt

			insert into #tempstatisticsYMDHdateInt
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From #tempstatisticsYMDHdateInt

			delete from #tempstatisticsYMDHdateInt
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin	
			Select uid, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier )
			insert into @lines3
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines
				union
				Select ID from A_ServerSipLines


			Select linenum, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines3 l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b

		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
				union
				Select ID from A_ServerSipLines


			Select prefix, ( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as AverageSec
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)a
				Group by prefix
			)b

		end	

	delete from #tempstatistics

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_CallTime' ) )
	drop procedure dbo.A_Stat_Office_Diagramm_CallTime
GO

CREATE   procedure [dbo].[A_Stat_Office_Diagramm_CallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int
as

begin
-- .  " "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdate') ) 
				select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDdate

			insert into #tempstatisticsYMDdate
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, m, d, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDdate

			delete from #tempstatisticsYMDdate										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdate') )
				select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDHdate 
				From A_Stat_Connections_1x1
			else
				delete from #tempstatisticsYMDHdate

			insert into #tempstatisticsYMDHdate
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From #tempstatisticsYMDHdate

			delete from #tempstatisticsYMDHdate
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin			
			Select uid, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union
				Select ID from A_ServerExtLines
				union
				Select ID from A_ServerGSMLines
				union
				Select ID from A_ServerSipLines


			Select linenum, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select ALineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.ALineId
	
					union all
	
					Select BLineNum as linenum, TimeAnswer, TimeStop
					From #tempstatistics ts
					inner join @lines l on l.lineid = ts.BLineId
				)a
				Group by linenum
			)b
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerExtLines
				union 
				Select ID from A_ServerGSMLines
				union
				Select ID from A_ServerSipLines
	

			Select prefix, ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, DatePart ( mi, length ) MI, DatePart ( ss, length ) S, DatePart ( ms, length ) MS
			From
			(
				Select prefix, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From
				(
					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = AUserId

					union all

					Select t1.prefix, 0 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
						A_Users u on u.id = BUserId
	
					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = ALineId

					union all

					Select t1.prefix, 1 as InnerAddrType, TimeAnswer, TimeStop
					From #tempstatistics t inner join 
						@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
						@lines4 l on l.lineid = BLineId
				)b
				Group by prefix
			)c

		end	

	delete from #tempstatistics

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_FlashedCalls' ) )
	drop procedure dbo.A_Stat_Office_Diagramm_FlashedCalls
GO

CREATE   procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int
as

begin
-- .  "  "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 0
--------------------------------------------------------------------
*/	

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype


	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsflash') )
		select top 0 sc1.*, sc2.ALineId A2LineId, sc2.BLineId B2LineId into #tempstatisticsflash From A_Stat_Connections_1x1 sc1 inner join A_Stat_Connections_1x1 sc2 on sc1.IDNext = sc2.Id
	else
		delete from #tempstatisticsflash

	insert into #tempstatisticsflash
		Select ts1.*, ts2.ALineId A2LineId, ts2.BLineId B2LineId
		FROM #tempstatistics ts1 inner join 
			#tempstatistics ts2 on ts1.idnext = ts2.id
		where not ( ts1.ALineId = ts2.ALineId and ts1.BLineID = ts2.BLineId ) 
			and not ( ts1.ALineId = ts2.BLineId and ts1.BLineID = ts2.ALineId )
			and not ( ts1.AUserId = 'AB000000-0000-0000-0000-000000000000' )
			and not ( ts1.BUserId = 'AB000000-0000-0000-0000-000000000000' )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From #tempstatisticsflash
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )											
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From #tempstatisticsflash
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			select uid, count ( * ) as count_
			From
			( 
				Select AUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 0 and 
					(AUserId != '00000000-0000-0000-0000-000000000000')
		
				union all

				Select BUserId as uid, TimeStop
				from #tempstatisticsflash
				where StopSide = 1 and
					(BUserId != '00000000-0000-0000-0000-000000000000')
			)a
			Group by uid								
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerSipLines

			select linenum, count ( * ) as count_
			from
			(
				select BLineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.BLineId = l.lineid

				union

				select ALineNum linenum, TimeStop
				from #tempstatisticsflash ts 
				inner join @lines l on ts.ALineId = l.lineid
			)a

			group by linenum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner join A_NumberPlanAction na on na.NumId = np.Id
					Inner join A_Rules r on na.ExtraId = r.Id
					Inner join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end

			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerSipLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = AUserId
				Group by prefix
					
				union all

					Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix
					
				union all

					Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = ALineId
				Group by prefix
					
				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatisticsflash t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix

		end	

	delete from #tempstatisticsflash
	delete from #tempstatistics

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Diagramm_HandledCalls' ) )
	drop procedure dbo.A_Stat_Office_Diagramm_HandledCalls
GO

CREATE   procedure [dbo].[A_Stat_Office_Diagramm_HandledCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int
as

begin
-- .  "  "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/		

	if not exists ( select * from tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete from #tempstatistics
		
	Insert into #tempstatistics 
	Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype

	Delete from #tempstatistics
	Where not ConnectionType in ( 4, 5 )

	Delete From #tempstatistics
	Where ConnectionType = 4 and ( not IdNext is null )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain


			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )						
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
				select BUserId, count ( * ) as count_
				from #tempstatistics
				group by BUserId													
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			select BLineNum, count ( * ) as count_
			from #tempstatistics
			group by BLineNum
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

			declare @lines table ( lineid uniqueidentifier )
			insert into @lines
				Select ID from A_ServerIntLines
				union 
				Select ID from A_ServerUSBLines
				union 
				Select ID from A_ServerSipLines


			Select prefix, sum ( count_ ) count_ from
			(
				Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 inner join 
					A_Users u on u.id = BUserId
				Group by prefix

				union all

				Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
				From #tempstatistics t inner join 
					@t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 inner join
					@lines l on l.lineid = BLineId
				Group by prefix
			)a
			Group by prefix
	end	

	delete from #tempstatistics

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Line_GetUsbLineIDByParentWPID' ) )
	drop procedure dbo.A_Line_GetUsbLineIDByParentWPID
GO

Create Procedure [dbo].[A_Line_GetUsbLineIDByParentWPID] 
	@wpid uniqueidentifier
As
Begin
--  LineId usb-  id  

	Select [ID] 
	From A_ServerUSBLines 
	Where ServerID = @wpid

	--    :
	-- Select [LineID]
	-- From A_Workplaces
	-- Where ParentId = @wpid
End
GO




if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Line_GetSipLineIDByParentWPID' ) )
	drop procedure dbo.A_Line_GetSipLineIDByParentWPID
GO

Create Procedure [dbo].[A_Line_GetSipLineIDByParentWPID] 
	@wpid uniqueidentifier
As
Begin
--  LineId sip-  id  

	Select [LineId] 
	From A_Workplaces
	Where ID = @wpid

	--   ??   ,   :
	-- Select [LineID]
	-- From A_Workplaces
	-- Where ParentId = @wpid
End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_Save' ) )
	drop procedure dbo.A_TaskManager_List_Save
GO

Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 )
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	--    ,    
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		Name 			= @name,
		Description 		= @description,
		ProjectId 		= @idproject,
		Type 			= @type,
		Query 			= @query,
		JoinedTable 		= @joinedtable,
		ColumnId 		= @columnid,
		ColumnsPhone 		= @columnsphone,
		ColumnName 		= @columnname,
		ColumnsViewed 		= @columnsviewed,
		ColumnsViewedDescription = @columnsvieweddescription,
		ColumnsSqlType 		= @columnssqltype,
		ColumnsSqlTypeSize 	= @columnssqltypesize
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize )
end
GO
