if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_GetQuery' ))
	drop procedure dbo.A_TaskManager_List_DirectDB_GetQuery
GO

Create procedure dbo.A_TaskManager_List_DirectDB_GetQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
		
		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
				 	Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
			end
			'

		exec sp_sqlexec @sql
	end	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--        
	set @sql = @sql + '
		--     ,   -     
		begin tran search_update_q

		Declare @id int, @efc int, @st int, @ln int
		Select top 1 @Id = Id, @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		From ' + @tableidx + ' with ( Index ( [' + @tableacindex + '] ) )
		Where AC = @min
			and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1, NIdx = NIdx + 1
		Where Id = @id

		--Select @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		--From ' + @tableidx + ' 
		--Where Id = @id

		commit tran search_update_q
		
		Select @efc, @st, @ln, ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQuery' ))
	drop procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
GO

Create procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

					Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
	@taskid uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 200 ),
	@table nvarchar ( 200 ),
	@query nvarchar ( 4000 ) = '',
	@colphone nvarchar ( 100 ),
	@colid nvarchar ( 100 ),
	@checkcondition nvarchar ( 1000 )
as
begin
	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--         ,        . Sysobjects .
	--if exists ( Select * From sysobjects
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tt' ) )
		drop table #tt
	Create table #tt ( cnt int )

	Set @sql = 'Select Count ( * ) From '
	if ( Len ( @query ) > 0 )
		set @sql = @sql + ' ( ' + @query + ' ) t '
	else
		set @sql = @sql + @table + ' t '
	Set @sql = @sql + '		
		Where (' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ') and ( ' + @checkcondition + ' )'
	
	Insert into #tt
		Exec sp_executesql @sql	

	declare @cnt int
	Select @cnt = cnt from #tt

	if ( @cnt = 0 )
	begin
		Set @sql = 'SET ROWCOUNT 1

			Update ' + @table + '
			Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			SET ROWCOUNT 0'
	
		exec sp_executesql @sql

	
		set @sql = '
			if not exists ( select id from ' + @tableidxn + ' Where Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ' and phone = ''' + @number + ''')
				Insert into ' + @tableidxn + ' 
				Values ( ' + cast ( @idinlist as nvarchar ( 10 ) ) + ', ''' + @number + ''' )'
		if exists ( Select * FROM sysobjects where id = object_id ( @tableidxn ) )
			exec sp_executesql @sql

		select 1
	end
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQuery' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQuery
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetQuery
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		And IdOperator = ' + @operator + '
		'
	--        ( )
	--        
	set @sql = @sql + '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where AC = @min
			and State = 0	
			and IdOperator = ' + @operator + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_GetQueryExact
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@idinlist int,
	@number nvarchar ( 200 )
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @tableopindex nvarchar ( 200 )
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''


	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	

		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			Declare @temp int set @temp = 1 --    @@rowcount>0 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 		Select top 100000 [' + @idfield + '], @k, 0, 0
					From ( ' + @query + ') t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
			end
			'

	exec sp_sqlexec @sql
	end	
	
	

	--  ,    (   )
	--        
	set @sql = '
		Declare @id int
		Select top 1  @Id = Id 
		From ' + @tableidx + ' 
		Where State = 0
			and IdOperator = ' + @operator + '
			and Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

		Update ' + @tableidx + ' 
		Set AC = AC + 1 
		Where Id = @id
		
		Select ' + @fields + '
		From ( ' + @query + ' )a
		Where [' + @idfield + '] = @id
		'

	exec sp_sqlexec @sql
end
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
GO


Create  procedure A_TaskManager_List_DistrDirectDB_RefreshOperator
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ) = '',
	@listquery nvarchar ( 4000 ) = '',
	@listidfield nvarchar ( 200 ) = '',
	@listnamefield nvarchar ( 200 ) = '',
	@count int = 0,
	@letter1 char ( 1 ) = '',
	@letter2 char ( 1 ) = ''
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @count > 0 )
  		    Set @sql = '
			SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

			Update ' + @tableidx + ' 
			Set IdOperator = ' + @operator + '
			Where IdOperator is null

			SET ROWCOUNT 0
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listtable != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct Id 
				From ' + @listtable + '
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listquery != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct Id 
				From (' + @listquery + ') a
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else 
		    Set @sql = '
			Update ' + @tableidx + ' 
			Set IdOperator = NULL
			Where IdOperator = ''00000000-0000-0000-0000-000000000000'''

			
		exec sp_sqlexec @sql
	end
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncQuery' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
GO


Create procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 200 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncTable' ))
	drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 200 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 [' + @idfield + '], @k, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetInfo' ))
	drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@id uniqueidentifier
as
begin

	Select Id, Name, Description, ProjectId, Type, 
		Query, JoinedTable, ColumnId, ColumnsPhone, 
		ColumnName, ColumnsViewed, ColumnsViewedDescription,
		ColumnsSqlType, ColumnsSqlTypeSize
	From A_TaskManager_Lists
	Where Id = @id or ProjectId = @id
	Order by Name
end
GO