if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Ext_Get' ) )
	Drop procedure dbo.A_Admin_Lines_Ext_Get
GO

Create Procedure [dbo].A_Admin_Lines_Ext_Get
	@id	uniqueidentifier
as
begin

	Select 	
		e.Id,		
		w.Name, 
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled, 
		Cast ( e.CanSimpleOut as bit ) as CanSimpleOut,
		Cast ( e.CanIp as bit ) as CanIp, 
		Cast ( e.CanAutoDial as bit ) as CanAutoDial,
		Cast ( e.CanMobile as bit ) as CanMobile, 
		e.Prefix,
		e.ExtNumber,
		e.Caption,
		e.DialType,
		e.ConnectedPBX,
		e.Type,
		e.StreamId,
		st.Name as StreamName
	
	From A_ServerExtLines e 
		Inner Join A_WorkPlaces w on e.ServerID = w.ID
		Left Join A_ServerStreams st on e.StreamId = st.Id

	Where ( e.ServerID = @id ) or ( @id = '00000000-0000-0000-0000-000000000000' )

	Order By SystemNum
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Int_Get' ) )
	Drop procedure dbo.A_Admin_Lines_Int_Get
GO

Create Procedure [dbo].A_Admin_Lines_Int_Get
	@id	uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName
	FROM 
	(	
		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId
		From A_ServerIntLines

		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			StreamId
		From A_ServerSipLines


		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			Cast ( NULL as uniqueidentifier ) as StreamId
		From A_ServerVirtualLines
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id
	Order By SystemNum
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId
		From A_ServerIntLines
		
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id
	Where e.ServerId = @id
	Order By SystemNum
    end	

end
GO

