--!!! !!!!!
BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Lists' ) )
begin	
	if not exists ( 
		select s.name, s.parent_obj, s1.name
		from sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id
		where s.name like 'PK_A_TaskManager_Lists' 
 		)
	begin		
		ALTER TABLE dbo.A_TaskManager_Lists ADD CONSTRAINT
		PK_A_TaskManager_Lists PRIMARY KEY CLUSTERED 
		(
		Id
		) ON [PRIMARY]
	end
end


GO
COMMIT

BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
CREATE TABLE dbo.Tmp_A_Contragent
	(
	idContragent uniqueidentifier NOT NULL,
	idContragent_int int NOT NULL IDENTITY (1, 1),
	Code nvarchar(100) NOT NULL,
	Name nvarchar(250) NOT NULL
	)  ON [PRIMARY]
GO

SET IDENTITY_INSERT dbo.Tmp_A_Contragent OFF
GO

IF EXISTS(SELECT * FROM dbo.A_Contragent)
	 EXEC('INSERT INTO dbo.Tmp_A_Contragent (idContragent, Code, Name)
		SELECT idContragent, Code, Name FROM dbo.A_Contragent TABLOCKX')
GO

ALTER TABLE dbo.A_ContragentContact
	DROP CONSTRAINT FK_A_ContragentContact_A_Contragent
GO

ALTER TABLE dbo.A_Clients_ClientForms
	DROP CONSTRAINT FK_A_Clients_ClientForms_A_Contragent
GO

ALTER TABLE dbo.A_Contragent_KeyWords
	DROP CONSTRAINT FK_A_Contragent_KeyWords_A_Contragent
GO

ALTER TABLE dbo.A_Contragent_ContragentGroup
	DROP CONSTRAINT FK_A_Contragent_ContragentGroup_A_Contragent
GO

DROP TABLE dbo.A_Contragent
GO

EXECUTE sp_rename N'dbo.Tmp_A_Contragent', N'A_Contragent', 'OBJECT'
GO

ALTER TABLE dbo.A_Contragent ADD CONSTRAINT
	PK_A_Contragent PRIMARY KEY CLUSTERED 
	(
	idContragent
	) ON [PRIMARY]

GO

COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_Contragent_ContragentGroup WITH NOCHECK ADD CONSTRAINT
	FK_A_Contragent_ContragentGroup_A_Contragent FOREIGN KEY
	(
	idContragent
	) REFERENCES dbo.A_Contragent
	(
	idContragent
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO

COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_Contragent_KeyWords WITH NOCHECK ADD CONSTRAINT
	FK_A_Contragent_KeyWords_A_Contragent FOREIGN KEY
	(
	idContragent
	) REFERENCES dbo.A_Contragent
	(
	idContragent
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO

COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_Clients_ClientForms WITH NOCHECK ADD CONSTRAINT
	FK_A_Clients_ClientForms_A_Contragent FOREIGN KEY
	(
	idContragent
	) REFERENCES dbo.A_Contragent
	(
	idContragent
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO

COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_ContragentContact WITH NOCHECK ADD CONSTRAINT
	FK_A_ContragentContact_A_Contragent FOREIGN KEY
	(
	idContragent
	) REFERENCES dbo.A_Contragent
	(
	idContragent
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO

COMMIT
GO

CREATE  UNIQUE  INDEX [idx_idContragentint] ON [dbo].[A_Contragent]([idContragent_int]) WITH  FILLFACTOR = 80 ON [PRIMARY]
GO

-------------------------------
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_TaskManager_Lists_ContragentCategories_A_ContragentCategory]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] DROP CONSTRAINT FK_A_TaskManager_Lists_ContragentCategories_A_ContragentCategory
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory]
GO

CREATE TABLE [dbo].[A_ContragentCategory] (
	[idCategory] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE Cyrillic_General_CI_AS NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ContragentCategory] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentCategory] PRIMARY KEY  CLUSTERED 
	(
		[idCategory]
	)  ON [PRIMARY] 
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_TaskManager_Lists_ContragentCategories_A_TaskManager_Lists]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] DROP CONSTRAINT FK_A_TaskManager_Lists_ContragentCategories_A_TaskManager_Lists
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_TaskManager_Lists_ContragentConditions_A_TaskManager_Lists]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] DROP CONSTRAINT FK_A_TaskManager_Lists_ContragentConditions_A_TaskManager_Lists
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_TaskManager_Lists_ContragentGroups_A_TaskManager_Lists]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] DROP CONSTRAINT FK_A_TaskManager_Lists_ContragentGroups_A_TaskManager_Lists
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentCategories]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentConditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentGroups]
GO
CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] (
	[idTaskList] [uniqueidentifier] NOT NULL ,
	[idCategory] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[Value] [nvarchar] (512) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[idTaskList] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] (
	[idTaskList] [uniqueidentifier] NOT NULL ,
	[idGroup] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO


ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentCategories] PRIMARY KEY  CLUSTERED 
	(
		[idTaskList],
		[idCategory]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentConditions] PRIMARY KEY  CLUSTERED 
	(
		[idForm],
		[idFormList],
		[idFormControl],
		[idTaskList]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentGroups] PRIMARY KEY  CLUSTERED 
	(
		[idTaskList],
		[idGroup]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [idxValue] ON [dbo].[A_TaskManager_Lists_ContragentConditions]([Value]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentCategories_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentCategories_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentConditions_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentConditions_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentGroups_A_ContragentGroup] FOREIGN KEY 
	(
		[idGroup]
	) REFERENCES [dbo].[A_ContragentGroup] (
		[idGroup]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentGroups_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO
BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_Clients_ClientForms
	DROP CONSTRAINT FK_A_Clients_ClientForms_A_ClientFormControl
GO
COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.A_Clients_ClientForms
	DROP CONSTRAINT FK_A_Clients_ClientForms_A_Contragent
GO
COMMIT
BEGIN TRANSACTION
CREATE TABLE dbo.Tmp_A_Clients_ClientForms
	(
	idValue uniqueidentifier NOT NULL,
	idForm uniqueidentifier NOT NULL,
	idFormList uniqueidentifier NOT NULL,
	idFormControl uniqueidentifier NOT NULL,
	idContragent uniqueidentifier NOT NULL,
	ValueStr nvarchar(2000) NULL,
	ValueInt decimal(10, 0) NULL,
	ValueDate datetime NULL,
	ValueDate2 datetime NULL,
	ValueUsed varchar(50) NULL,
	idValueParent uniqueidentifier NULL
	)  ON [PRIMARY]
GO
IF EXISTS(SELECT * FROM dbo.A_Clients_ClientForms)
	 EXEC('INSERT INTO dbo.Tmp_A_Clients_ClientForms (idValue, idForm, idFormList, idFormControl, idContragent, ValueStr, ValueInt, ValueDate, ValueDate2, ValueUsed, idValueParent)
		SELECT idValue, idForm, idFormList, idFormControl, idContragent, ValueStr, CONVERT(decimal(10, 0), ValueInt), ValueDate, ValueDate2, ValueUsed, idValueParent FROM dbo.A_Clients_ClientForms TABLOCKX')
GO
DROP TABLE dbo.A_Clients_ClientForms
GO
EXECUTE sp_rename N'dbo.Tmp_A_Clients_ClientForms', N'A_Clients_ClientForms', 'OBJECT'
GO
ALTER TABLE dbo.A_Clients_ClientForms ADD CONSTRAINT
	PK_A_Clients_ClientForms PRIMARY KEY CLUSTERED 
	(
	idValue
	) ON [PRIMARY]

GO
ALTER TABLE dbo.A_Clients_ClientForms WITH NOCHECK ADD CONSTRAINT
	FK_A_Clients_ClientForms_A_Contragent FOREIGN KEY
	(
	idContragent
	) REFERENCES dbo.A_Contragent
	(
	idContragent
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO
ALTER TABLE dbo.A_Clients_ClientForms WITH NOCHECK ADD CONSTRAINT
	FK_A_Clients_ClientForms_A_ClientFormControl FOREIGN KEY
	(
	idFormControl
	) REFERENCES dbo.A_ClientFormControl
	(
	idFormControl
	) ON DELETE CASCADE
	 NOT FOR REPLICATION

GO
COMMIT

