if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Conditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Conditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedLists]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Rigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Rigths]
GO

CREATE TABLE [dbo].[A_ContragentCategory_Conditions] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[Value] [nvarchar] (512) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[idCategory] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ContragentCategory_GrantedForms] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idCategory] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ContragentCategory_GrantedLists] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idCategory] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ContragentCategory_Rigths] (
	[idCategory] [uniqueidentifier] NOT NULL ,
	[idSubject] [uniqueidentifier] NOT NULL ,
	[isGroup] [bit] NOT NULL ,
	[AccessType] [tinyint] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ContragentCategory_Conditions] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentCategory_Conditions] PRIMARY KEY  CLUSTERED 
	(
		[idForm],
		[idFormList],
		[idFormControl],
		[idCategory]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ContragentCategory_GrantedForms] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentCategory_GrantedForms] PRIMARY KEY  CLUSTERED 
	(
		[idForm],
		[idCategory]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ContragentCategory_GrantedLists] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentCategory_GrantedLists] PRIMARY KEY  CLUSTERED 
	(
		[idForm],
		[idFormList],
		[idCategory]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [idxCategory] ON [dbo].[A_ContragentCategory_Rigths]([idCategory]) WITH  FILLFACTOR = 80 ON [PRIMARY]
GO

 CREATE  INDEX [idxSubject] ON [dbo].[A_ContragentCategory_Rigths]([idSubject]) WITH  FILLFACTOR = 80 ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ContragentCategory_Conditions] ADD 
	CONSTRAINT [FK_A_ContragentCategory_Conditions_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_ContragentCategory_Conditions_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ContragentCategory_GrantedForms] ADD 
	CONSTRAINT [FK_A_ContragentCategory_GrantedForms_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_ContragentCategory_GrantedForms_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ContragentCategory_GrantedLists] ADD 
	CONSTRAINT [FK_A_ContragentCategory_GrantedLists_A_ClientFormList] FOREIGN KEY 
	(
		[idFormList]
	) REFERENCES [dbo].[A_ClientFormList] (
		[idFormList]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_ContragentCategory_GrantedLists_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ContragentCategory_Rigths] ADD 
	CONSTRAINT [FK_A_ContragentCategory_Rigths_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_Categories_DeleteCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_Categories_DeleteCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearConditions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearGrantedForms]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Conditions_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedForms_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_GrantedLists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveCondition]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveGrantedFormList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientCategory_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE  Procedure [dbo].[A_Admin_Categories_DeleteCategory]
@@CategoryId uniqueidentifier
as
begin
 delete A_ContragentCategory
 where IdCategory = @@CategoryId
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_ClearConditions]
@@IdCategory uniqueidentifier
as
begin
 delete A_ContragentCategory_Conditions
 where IdCategory = @@IdCategory
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_ClearGrantedFormLists]
@@IdCategory uniqueidentifier
as
begin
 delete A_ContragentCategory_GrantedLists
 where IdCategory = @@IdCategory
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_ClearGrantedForms]
@@IdCategory uniqueidentifier
as
begin
 delete A_ContragentCategory_GrantedForms
 where IdCategory = @@IdCategory
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_ClearRigths]
@@IdCategory uniqueidentifier
as
begin
 delete A_ContragentCategory_Rigths
 where IdCategory = @@IdCategory
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_Conditions_GetList]
as
begin
 Select idForm, idFormList, idFormControl, [Value], idCategory
 From A_ContragentCategory_Conditions
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO





--exec A_Admin_ClientCategory_GetList
CREATE   Procedure [dbo].[A_Admin_ClientCategory_GetList]
as
begin
 begin tran
 --   
 create table tmp_categoryforms( IdCategory uniqueidentifier, [Name] nvarchar(1000) )

 insert tmp_categoryforms( IdCategory, [Name] )
 Select IdCategory, f.[Name]
 From A_ContragentCategory_GrantedForms gf
	inner join A_ClientForm f on f.IdForm = gf.IdForm

 insert tmp_categoryforms( IdCategory, [Name] )
 Select IdCategory, f.[Name]
 From A_ContragentCategory_GrantedLists gf
	inner join A_ClientForm f on f.IdForm = gf.IdForm
 where not exists( select IdCategory from tmp_categoryforms where IdCategory = gf.IdCategory and [Name] = f.[Name] )
 

 Select c.idCategory, [Name], substring( dbo.GetClientCategoryDescription( c.idCategory ), 3, len( dbo.GetClientCategoryDescription( c.idCategory ) ) ) as 'FormUsed'
 From A_ContragentCategory  c

 drop table tmp_categoryforms
 commit tran 
end





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_GrantedForms_GetList]
as
begin
 Select idForm, idCategory
 From A_ContragentCategory_GrantedForms
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_GrantedLists_GetList]
as
begin
 Select idForm, idFormList, idCategory
 From A_ContragentCategory_GrantedLists
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure [dbo].[A_Admin_ClientCategory_Rigths_GetList]
as
begin
 Select idSubject, isGroup, AccessType, idCategory
 From A_ContragentCategory_Rigths
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE  Procedure [dbo].[A_Admin_ClientCategory_SaveCommon]
@@Id uniqueidentifier,
@@Name nvarchar(512)
as
begin
 if( not exists( select IdCategory from A_ContragentCategory where IdCategory = @@Id ) )
	insert A_ContragentCategory ( idCategory, [Name] )
	values( @@Id, @@Name )
 else
	update A_ContragentCategory
	set [Name] = @@Name
	where idCategory = @@Id
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



create Procedure [dbo].[A_Admin_ClientCategory_SaveCondition]
@@IdCategory uniqueidentifier,
@@IdForm uniqueidentifier,
@@IdFormList uniqueidentifier,
@@IdFormControl uniqueidentifier,
@@Value nvarchar(512)
as
begin
 insert A_ContragentCategory_Conditions ( IdCategory, IdForm, IdFormList, IdFormControl, [Value] )
 values( @@IdCategory, @@IdForm, @@IdFormList, @@IdFormControl, @@Value )
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



create Procedure [dbo].[A_Admin_ClientCategory_SaveGrantedForm]
@@IdCategory uniqueidentifier,
@@IdForm uniqueidentifier
as
begin
 insert A_ContragentCategory_GrantedForms ( IdCategory, IdForm )
 values( @@IdCategory, @@IdForm )
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



create Procedure [dbo].[A_Admin_ClientCategory_SaveGrantedFormList]
@@IdCategory uniqueidentifier,
@@IdForm uniqueidentifier,
@@IdFormList uniqueidentifier
as
begin
 insert A_ContragentCategory_GrantedLists ( IdCategory, IdForm, IdFormList )
 values( @@IdCategory, @@IdForm, @@IdFormList )
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



create Procedure [dbo].[A_Admin_ClientCategory_SaveRigth]
@@IdCategory uniqueidentifier,
@@SubjectId uniqueidentifier,
@@isGroup bit,
@@AccessType tinyint
as
begin
 insert A_ContragentCategory_Rigths ( IdCategory, idSubject, isGroup, AccessType )
 values( @@IdCategory, @@SubjectId, @@isGroup, @@AccessType )
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetClientCategoryDescription]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[GetClientCategoryDescription]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE  FUNCTION dbo.GetClientCategoryDescription( @id uniqueidentifier )
RETURNS NVARCHAR(1000)
AS
BEGIN
DECLARE @Result NVARCHAR(4000)
SET @Result = ''
SELECT @Result = @Result + ', ' + [Name] FROM dbo.tmp_categoryforms WHERE IdCategory = @id
RETURN RTRIM(@Result)
END


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

