if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ClientFormColumns]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ClientFormColumns]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentCategories]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentCategories]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentConditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentConditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Lists_ContragentGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_TaskManager_Lists_ContragentGroups]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ClientFormColumns] (
	[idTaskList] [uniqueidentifier] NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] (
	[idTaskList] [uniqueidentifier] NOT NULL ,
	[idCategory] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[Value] [nvarchar] (512) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[idTaskList] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] (
	[idTaskList] [uniqueidentifier] NOT NULL ,
	[idGroup] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ClientFormColumns] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ClientFormColumns] PRIMARY KEY  CLUSTERED 
	(
		[idTaskList],
		[idForm],
		[idFormList],
		[idFormControl]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentCategories] PRIMARY KEY  CLUSTERED 
	(
		[idTaskList],
		[idCategory]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentConditions] PRIMARY KEY  CLUSTERED 
	(
		[idForm],
		[idFormList],
		[idFormControl],
		[idTaskList]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_TaskManager_Lists_ContragentGroups] PRIMARY KEY  CLUSTERED 
	(
		[idTaskList],
		[idGroup]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [idxValue] ON [dbo].[A_TaskManager_Lists_ContragentConditions]([Value]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ClientFormColumns] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ClientFormColumns_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ClientFormColumns_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentCategories] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentCategories_A_ContragentCategory] FOREIGN KEY 
	(
		[idCategory]
	) REFERENCES [dbo].[A_ContragentCategory] (
		[idCategory]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentCategories_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentConditions] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentConditions_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentConditions_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_TaskManager_Lists_ContragentGroups] ADD 
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentGroups_A_ContragentGroup] FOREIGN KEY 
	(
		[idGroup]
	) REFERENCES [dbo].[A_ContragentGroup] (
		[idGroup]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_TaskManager_Lists_ContragentGroups_A_TaskManager_Lists] FOREIGN KEY 
	(
		[idTaskList]
	) REFERENCES [dbo].[A_TaskManager_Lists] (
		[Id]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

