if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO










CREATE          Procedure [dbo].[A_CallCenter_Office_Contragents_SearchByCustomFilterAndGroups]
as
begin

-- -    
declare @@EnableAdditionalSearchFilters bit
set @@EnableAdditionalSearchFilters = 0
if( exists( select top 1 * from ##TempSearchByCustomFilter ) )
	set @@EnableAdditionalSearchFilters = 1 

-- -   
declare @@EnableAdditionalSearchFilterGroups bit
set @@EnableAdditionalSearchFilterGroups = 0
if( exists( select top 1 idGroup from ##TempSearchByCustomFilterGroups ) )
	set @@EnableAdditionalSearchFilterGroups = 1 

--  
select c.idContragent, Code, c.[Name], tmp_gr.IdGroup
into #tmp_clients
From A_Contragent c
	left join A_Contragent_ContragentGroup ccg on c.IdContragent = ccg.IdContragent
	left join A_Contragent_KeyWords ck on c.IdContragent = ck.IdContragent
	left join A_KeyWord k on ck.IdKeyWord = k.IdKeyWord

	left join A_ContragentContact cc on c.IdContragent = cc.IdContragent

	left join A_Clients_ClientForms ccf on c.IdContragent = ccf.IdContragent
	left join ##TempSearchByCustomFilter tmp on ccf.IdForm = tmp.IdForm 
				and ccf.IdFormList = tmp.IdFormList 
				and ccf.IdFormControl = tmp.IdFormControl
	left join ##TempSearchByCustomFilterGroups tmp_gr on isnull ( ccg.IdGroup, '00000000-0000-0000-0000-000000000000' ) = tmp_gr.IdGroup or tmp_gr.IdGroup = '00000000-0000-0000-0000-000000000000'
Where 	
	( @@EnableAdditionalSearchFilterGroups = 0 and --   
		( case ccf.ValueUsed 
		  when 'ValueStr' then ValueStr
		  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
		  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
		  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
		 --   
		  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
	    	  end )  like dbo.PrepareStrToLike( tmp.Value ) 
	)
	or
	( ( @@EnableAdditionalSearchFilterGroups = 1 and --   	    
		tmp_gr.IdGroup is not null ) and --      " " = '00000000-0000-0000-0000-000000000000'
		( @@EnableAdditionalSearchFilters = 1 and --   
		  ( case ccf.ValueUsed 
		  when 'ValueStr' then ValueStr
		  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
		  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
		  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
		 --   
		  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
	    	  end )  like dbo.PrepareStrToLike( tmp.Value ) )
	)
	or
	(  @@EnableAdditionalSearchFilterGroups = 1  --   	    
		 and --   
		( @@EnableAdditionalSearchFilters = 0 and --   
		  ( tmp_gr.IdGroup is not null or
		  ( case ccf.ValueUsed 
		  when 'ValueStr' then ValueStr
		  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
		  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
		  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
		 --   
		  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
	    	  end )  like dbo.PrepareStrToLike( tmp.Value ) ) )
	)

--   "" (    -   ""   "" )
declare @CountSearchConsitions int, @CountResults int
declare @ExistClientsInGroup bit --  

--select * from #tmp_clients
select @CountSearchConsitions = count ( * )
from ##TempSearchByCustomFilter
--where IdGroup != '00000000-0000-0000-0000-000000000000'

select idContragent, count( * ) cntSearchCondInRes
into #tmp_clientsfinded
from #tmp_clients
group by idContragent, idGroup
having count( * ) = @CountSearchConsitions or @CountSearchConsitions = 0


--  
Select distinct tmp1. idContragent, Code, [Name] 
from #tmp_clients tmp1
	inner join #tmp_clientsfinded tmp2 on tmp1.idContragent = tmp2.idContragent

	--  
	drop table #tmp_clients
	--  
	drop table #tmp_clientsfinded

	-- ,   A_CallCenter_Office_Contragents_PrepareSearchByCustomFilter
	drop table ##TempSearchByCustomFilter 

	-- ,   A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups
	--    
	drop table ##TempSearchByCustomFilterGroups 

end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

