if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO









CREATE        Procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
@@IdCategory uniqueidentifier
as
begin

-- -   
declare @@EnableAdditionalSearchFilterGroups bit
set @@EnableAdditionalSearchFilterGroups = 0
if( exists( select top 1 idGroup from ##TempSearchByCustomFilterGroups ) )
	set @@EnableAdditionalSearchFilterGroups = 1 

--  
select distinct c.idContragent, Code, c.[Name]
into #tmp_clients
From A_Contragent c
	left join A_Contragent_ContragentGroup ccg on c.IdContragent = ccg.IdContragent
	left join A_Contragent_KeyWords ck on c.IdContragent = ck.IdContragent
	left join A_KeyWord k on ck.IdKeyWord = k.IdKeyWord

	left join A_ContragentContact cc on c.IdContragent = cc.IdContragent

	left join A_Clients_ClientForms ccf on c.IdContragent = ccf.IdContragent
	left join A_ContragentCategory_Conditions cat on ccf.IdForm = cat.IdForm 
				and ccf.IdFormList = cat.IdFormList 
				and ccf.IdFormControl = cat.IdFormControl
	left join ##TempSearchByCustomFilterGroups tmp_gr on isnull ( ccg.IdGroup, '00000000-0000-0000-0000-000000000000' ) = tmp_gr.IdGroup or tmp_gr.IdGroup = '00000000-0000-0000-0000-000000000000'
Where 	
	( ( @@EnableAdditionalSearchFilterGroups = 1 and --   	    
		tmp_gr.IdGroup is not null ) and --      " " = '00000000-0000-0000-0000-000000000000'
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 or 
			( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  or
	  ( @@EnableAdditionalSearchFilterGroups = 0 and --   
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 or 
			( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  )
	)

--  
Select distinct idContragent, Code, [Name] 
from #tmp_clients

	--  
	drop table #tmp_clients

	-- ,   A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups
	--    
	drop table ##TempSearchByCustomFilterGroups 

end
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_PrepareQueryToClientTable]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_PrepareQueryToClientTable]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO







CREATE            Procedure [dbo].[A_TaskManager_PrepareQueryToClientTable]

@@idTaskList uniqueidentifier

as
begin
begin tran PrepareQueryToClientTable

--if( exists ( select * from tempdb..sysobjects where name like '#clienttable' ) )
	--drop table #clienttable

create table #clienttable ( idContragent_int int primary key )

--1     -      
--     
declare tablefields_cursor cursor fast_forward
for
 select f.[Name] + '.' + fl.[Name] + '.' + fc.[Name] 
 from A_TaskManager_Lists_ClientFormColumns t
	inner join A_ClientForm f on t.idForm = f.IdForm
	inner join A_ClientFormList fl on t.idFormList = fl.IdFormList 
	inner join A_ClientFormControl fc on t.IdFormControl = fc.IdFormControl
 where t.IdTaskList = @@idTaskList 

 -- 
 declare @ColName nvarchar( 512 )
 open tablefields_cursor
 fetch next from tablefields_cursor
 into @ColName
 
 declare @sql nvarchar( 1000 )
set @sql = 'alter table #clienttable
			          add [@ColName] nvarchar( 1000 )'
 while @@fetch_status = 0
 begin
	set @sql = replace ( @sql, '@ColName', @ColName )
	exec sp_executesql @sql 
 
	fetch next from tablefields_cursor
	into @ColName
 end
 close tablefields_cursor
 deallocate tablefields_cursor
 

--1/2          
--   
create table #table_caption ( idContragent_int int,  idForm uniqueidentifier, idFormList uniqueidentifier, idFormControl uniqueidentifier, [Value] nvarchar( 2000 ), Caption nvarchar(512)  )
insert #table_caption ( idContragent_int, idForm, idFormList, idFormControl, Caption )
   select c.idContragent_int, t.idForm, t.idFormList, t.idFormControl,
		f.[Name] + '.' + fl.[Name] + '.' + fc.[Name]
 from A_Clients_ClientForms cf
	inner join A_Contragent c on c.idContragent = cf.idContragent
	inner join A_TaskManager_Lists_ClientFormColumns t
		on t.idForm = cf.idForm and t.idFormList = cf.idFormList and t.idFormControl = cf.idFormControl
	inner join A_ClientForm f on cf.idForm = f.IdForm
	inner join A_ClientFormList fl on cf.idFormList = fl.IdFormList 
	inner join A_ClientFormControl fc on cf.IdFormControl = fc.IdFormControl
 where t.idTaskList = @@idTaskList


 --      #table_caption    
 declare tabletemp_cursor cursor fast_forward
 for 
	select idContragent_int, idForm, idFormList, idFormControl 
	from #table_caption
 open tabletemp_cursor
 
 declare @idContragent_int int
 declare @idForm uniqueidentifier
 declare @idFormList uniqueidentifier
 declare @idFormControl uniqueidentifier
 fetch next from tabletemp_cursor
 into @idContragent_int, @idForm, @idFormList, @idFormControl
 

--    GetValue
 set @sql =
	'update #table_caption
	set value = ''@returnedvalue''
	where idContragent_int = @idContragent_int'
 declare @sqlpart nvarchar( 2000 )
 create table #tmp_getvalue ( result nvarchar( 1000 ) )
 while @@fetch_status = 0
 begin
	insert #tmp_getvalue
	exec A_CallCenter_Office_Contragents_GetValueForScript @idContragent_int , @idForm, @idFormList, @idFormControl
	
	select top 1  @sqlpart = result from #tmp_getvalue
	set @sql = replace ( @sql, '@returnedvalue', @sqlpart )
	set @sql = replace ( @sql, '@idContragent_int', @idContragent_int )
	
	--print @sql 

	exec sp_executesql @sql

	fetch next from tabletemp_cursor
	into @idContragent_int, @idForm, @idFormList, @idFormControl
 end

 close tabletemp_cursor
 deallocate tabletemp_cursor
 
--select * from #table_caption
 --2        
 declare tablevalues_cursor cursor fast_forward
 for 
	select idContragent_int, Value, Caption
	from #table_caption

 --2a     ( )
insert #clienttable ( idContragent_int )
select distinct idContragent_int
from #table_caption


--3   tablevalues_cursor     
--          -    null   
declare @colvalue nvarchar( 1000 )
declare @colcaption nvarchar( 512 )

open tablevalues_cursor
fetch next from tablevalues_cursor
into @idContragent_int, @colvalue, @colcaption

set @sql = 'update #clienttable set [@columnname] = @columnvalue where idContragent_int = @idContragent'
while @@fetch_status = 0
begin
	
	set @sql = replace ( @sql, '@columnname', @colcaption )
	set @sql = replace ( @sql, '@columnvalue', @colvalue )
	set @sql = replace ( @sql, '@idContragent', @idContragent_int )

	print @sql
	exec sp_executesql @sql 
	fetch next from tablevalues_cursor
	into @idContragent_int, @colvalue, @colcaption
end

close tablevalues_cursor
deallocate tablevalues_cursor

 select * from #clienttable

commit tran PrepareQueryToClientTable
end
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO





if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO












CREATE          Procedure [dbo].[A_CallCenter_Office_Contragents_SearchByUserFilterAndGroups]
@@IdCategory uniqueidentifier
as
begin

-- -   
declare @@EnableAdditionalSearchFilterGroups bit
set @@EnableAdditionalSearchFilterGroups = 0
if( exists( select top 1 idGroup from ##TempSearchByCustomFilterGroups ) )
	set @@EnableAdditionalSearchFilterGroups = 1 

--  
select distinct c.idContragent, Code, c.[Name]
into #tmp_clients
From A_Contragent c
	left join A_Contragent_ContragentGroup ccg on c.IdContragent = ccg.IdContragent
	left join A_Contragent_KeyWords ck on c.IdContragent = ck.IdContragent
	left join A_KeyWord k on ck.IdKeyWord = k.IdKeyWord

	left join A_ContragentContact cc on c.IdContragent = cc.IdContragent

	inner join A_Clients_ClientForms ccf on c.IdContragent = ccf.IdContragent
	inner join A_ContragentCategory_Conditions cat on ccf.IdForm = cat.IdForm 
				and ccf.IdFormList = cat.IdFormList 
				and ccf.IdFormControl = cat.IdFormControl
	left join ##TempSearchByCustomFilterGroups tmp_gr on isnull ( ccg.IdGroup, '00000000-0000-0000-0000-000000000000' ) = tmp_gr.IdGroup or tmp_gr.IdGroup = '00000000-0000-0000-0000-000000000000'
Where 	cat.IdCategory = @@IdCategory and
	( ( @@EnableAdditionalSearchFilterGroups = 1 and --   	    
		tmp_gr.IdGroup is not null ) and --      " " = '00000000-0000-0000-0000-000000000000'
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 or 
			( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  or
	  ( @@EnableAdditionalSearchFilterGroups = 0 and --   
		( (--   
			case ccf.ValueUsed 
			  when 'ValueStr' then ValueStr
			  when 'ValueInt' then cast ( ValueInt as nvarchar( 255 ) )
			  when 'ValueDate' then cast( ValueDate as nvarchar( 255 ) )
			  when 'ValueDate2' then cast( ValueDate as nvarchar( 255 ) )
			 --   
			  when 'ValueLink' then dbo.Contragents_GetValueByLink( ccf.IdValueParent )
		    	  end like dbo.PrepareStrToLike( cat.Value )
		   )
			 --or 
			--( exists( Select IdCategory from A_ContragentCategory Where IdCategory = @@IdCategory ) and 
			--  not exists( Select IdCategory from A_ContragentCategory_Conditions Where IdCategory = @@IdCategory ) )
		)
	  )
	)
--select * from #tmp_clients
--  
Select distinct idContragent, Code, [Name] 
from #tmp_clients

	--  
	drop table #tmp_clients

	-- ,   A_CallCenter_Office_Contragents_PrepareSearchByCustomFilterGroups
	--    
	drop table ##TempSearchByCustomFilterGroups 

end
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

