
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_FreeTime' ) )
	Drop procedure dbo.A_TaskManager_OperatorsAll_Get_FreeTime
GO


Create procedure [dbo].[A_TaskManager_OperatorsAll_Get_FreeTime]
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Declare @tmp Table ( timestop DateTime, auserid UniqueIdentifier, buserid UniqueIdentifier )
	Insert into @tmp 
		Select TimeStop, AUserId, BUserId
		From A_Stat_Connections_1x1
		Where TimeStart > DateAdd ( d, -3, @dtnow )

	Select u.id, 
		--Max ( TimeStop ) as TimeStop_Last,
		Convert ( float, @dtnow - Max ( IsNull ( TimeStop, @dtnow ) ) ) as MaxFreeTime_Days		
	From @tmp sc--With ( TabLock )
		Inner join A_Users u on sc.AUserId = u.id or sc.BUserId = u.Id	
	Group By u.Id
	Order By MaxFreeTime_Days Desc

/*
	Select u.id, 
		--Max ( TimeStop ) as TimeStop_Last,
		Convert ( float, @dtnow - Max ( IsNull ( TimeStop, @dtnow ) ) ) as MaxFreeTime_Days
	From A_Stat_Connections_1x1 sc--With ( TabLock )
		Inner join A_USers u on sc.AUserId = u.id or sc.BUserId = u.Id	
	Group by u.Id
	order by MaxFreeTime_Days desc
*/
end
GO
