if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns'))
	drop table dbo.A_PlugIns
GO

Create table dbo.A_PlugIns
(
	Id uniqueidentifier not null primary key,
	Type int not null, --COM, NET
	ObjectName nvarchar ( 200 ),
	Name nvarchar ( 200 ) not null,
	Description nvarchar (4000),
	Path nvarchar ( 1000 )
)
GO


if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_Save'))
	drop procedure dbo.A_PlugIns_Save
GO

Create procedure dbo.A_PlugIns_Save
	@id uniqueidentifier,
	@type int,
	@objectname nvarchar ( 200 ) = null,
	@name nvarchar ( 200 ),
	@description nvarchar ( 4000 ) = null,
	@path nvarchar ( 1000 ) = null
as
begin
	Update A_PlugIns
	Set 	Type = @type,
		ObjectName = @objectname,
		Name = @name,
		Description = @description,
		Path = @path
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_PlugIns ( Id, Type, ObjectName, Name, Description, Path )
		Values ( @id, @type, @objectname, @name, @description, @path )			
end
GO


if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_Delete'))
	drop procedure dbo.A_PlugIns_Delete
GO

Create procedure dbo.A_PlugIns_Delete
	@id uniqueidentifier	
as
begin
	Delete 
	From A_PlugIns
	Where Id = @id
end
GO



if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_GetAll'))
	drop procedure dbo.A_PlugIns_GetAll
GO

Create procedure dbo.A_PlugIns_GetAll
as
begin
	Select * 
	From A_PlugIns
	Order by Name	
end
GO
