if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_DB_ClearTaskOptimize' ) )
	Drop procedure dbo.A_DB_ClearTaskOptimize
GO

Create procedure dbo.A_DB_ClearTaskOptimize
as
begin
	
	-- 
	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()


	--      
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	--  maxsize    1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )


	--       
	Truncate table dbo.A_TaskManager_SubTasks
	Truncate table dbo.A_TaskManager_SubTaskNumber
	Truncate table dbo.A_TaskManager_SubTaskEfforts
	Truncate table dbo.A_TaskManager_Task_IncomingCalls


	--  
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskNumber' )	
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskEfforts' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_Task_IncomingCalls' )


	--    -      
	Declare tcursor Cursor For
		Select name 
		From sysobjects 
		Where ( name like 'A_TaskManager_dIdx%' 
			or name like 'A_TaskManager_Idx%')
			And xtype='U'


	Declare @nm varchar(500)
	Declare @sql nvarchar(500)

	Open tcursor
	Fetch Next From tcursor Into @nm

	While @@fetch_status = 0
	Begin
		set @sql = ' Drop Table dbo.[' + @nm + ']'

		exec sp_executesql @stmt =@sql
		print @sql

		Fetch Next From tcursor Into @nm
	End

	Close tcursor
	Deallocate tcursor

	

	--  
	DBCC SHRINKDATABASE (oktell)

	--        
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )
end
GO
