if Exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( 'oktell_cc_temp.dbo.A_Sms' ) )
DROP Table oktell_cc_temp.dbo.A_Sms
GO

Create table oktell_cc_temp.dbo.A_Sms
(	
	Id int identity ( 1, 1 ) not null primary key,
--	IdGuid uniqueidentifier not null,
	Received bit not null,
	DT DateTime not null,
	Sender nvarchar ( 100 ) not null,
	Receiver nvarchar ( 100 ) not null,
	SmsText nvarchar ( 2000 ) not null,
	PushId int null,
	Delivered bit null,
	DeliveredDT DateTime null
)
GO


if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_AddReceived' ) )
DROP Procedure dbo.A_Sms_AddReceived
GO

Create procedure dbo.A_Sms_AddReceived
--	@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 )
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText )
	Values
	( 	--@idguid, 
		1, @dt, @sender, @receiver, @smstext )

	select cast ( @@identity as int )
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_AddSent' ) )
DROP Procedure dbo.A_Sms_AddSent
GO

Create procedure dbo.A_Sms_AddSent
	--@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 ),
	@pushid int,
	@delivered bit = null,
	@delivereddt datetime = null
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText, PushId, Delivered, DeliveredDT )
	Values
	( 	
		--@idguid, 
		0, @dt, @sender, @receiver, @smstext, @pushid, @delivered, @delivereddt )

	select cast ( @@identity as int )
end
GO



if Exists ( Select * FROM sysobjects Where Id = object_id ( 'dbo.A_Sms_UpdateDelivered' ) )
DROP Procedure dbo.A_Sms_UpdateDelivered
GO

Create procedure dbo.A_Sms_UpdateDelivered
	@id int = 0,
	@pushid int = 0,	
	--@idguid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@delivereddt datetime
as
begin
	Update oktell_cc_temp.dbo.A_Sms
	Set 	Delivered = 1,
		DeliveredDT = @delivereddt
	Where Id = @id  
		or PushId = @pushid
		--or IdGuid = @idguid
end
GO




if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_CallCenter_Temp_CreateTables' ) )
	Drop procedure [dbo].[A_CallCenter_Temp_CreateTables]
GO

Create Procedure [dbo].[A_CallCenter_Temp_CreateTables]
as
begin
	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
	( 
		IdProject	uniqueidentifier NOT NULL,
		IdTask 		uniqueidentifier NOT NULL,
		IsOutput	bit NOT NULL,
		IdEffort	uniqueidentifier NOT NULL,
		IdOperator 	uniqueidentifier,
		IdInList	int NOT NULL,
		AbonentNumber 	nvarchar ( 20 ) NOT NULL,
		CallResult	int NOT NULL,
		CallResultInfo	nvarchar ( 100 ) Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop	DateTime Not Null,
		IdConn		uniqueidentifier,
		IdChain 	uniqueidentifier,	
		IdAUser		uniqueidentifier,
		IdBUser		uniqueidentifier,
		IdExtLine 	uniqueidentifier NOT NULL,
		LenTime 	float NOT NULL, 
		LenQueue 	float NOT NULL,
		IsBetweenOp	bit,
		OpponentInfo 	nvarchar ( 100 ),
		IsHandled 	bit NOT NULL,
		IsSuccess	bit Not NULL,
		IsRecorded	bit,
		IdRecDir	int,
		ALineNum	nvarchar ( 5 ),
		BLineNum	nvarchar ( 5 ),
		--ARecFile	nvarchar ( 100 ),
		--BRecFile 	nvarchar ( 100 ),
		UserResult 	int
	)	
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
	( 		
		Id		int identity ( 1, 1 ) not null primary key,
		IdTask 		uniqueidentifier,
		IsOutput	bit,	
		IdOperator 	uniqueidentifier NOT NULL,
		CallResult	int,
		State		int Not Null,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		DateTimeStop 	DateTime NOT NULL, 
		LenTime 	float NOT NULL,
		ICode 		int NULL	
	)
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		IdTask 		uniqueidentifier NOT NULL,
		IdProject	uniqueidentifier Not NULL,
		DateTimeStart 	DateTime NOT NULL, 
		DateStart 	DateTime NOT NULL, 
		TimeStart 	DateTime NOT NULL,
		CountQueue	int Not Null,
		CountOperator	int Not Null,
		CountTalking	int Not Null,
		elt1WaitStart	DateTime NOT NULL,
		elt1WaitSec	int Not null,
	)
	end



	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	(
		Id int not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ) not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	(
		Id uniqueidentifier not null primary key,
		Name nvarchar ( 100 ),
		p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
		s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
		LastDT DateTime	)

	if not exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( '[oktell_cc_temp].[dbo].[A_Sms]' ) )
	Create table oktell_cc_temp.dbo.A_Sms
	(	
		Id int identity ( 1, 1 ) not null primary key,
	--	IdGuid uniqueidentifier not null,
		Received bit not null,
		DT DateTime not null,
		Sender nvarchar ( 100 ) not null,
		Receiver nvarchar ( 100 ) not null,
		SmsText nvarchar ( 2000 ) not null,
		PushId int null,
		Delivered bit null,
		DeliveredDT DateTime null,
		IdServer nvarchar ( 50 )
	)

end
GO


if exists ( Select * FROM oktell_cc_temp..sysobjects where id = object_id ( 'oktell_cc_temp.dbo.A_Sms' ) )
if not Exists ( Select * From oktell_cc_temp.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Sms' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IdServer' )
	Alter Table oktell_cc_temp.dbo.A_Sms
	Add IdServer nvarchar ( 50 )
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Sms_AddReceived' ) )
	drop procedure dbo.A_Sms_AddReceived
GO


Create procedure dbo.A_Sms_AddReceived
--	@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 ),
	@idserver nvarchar ( 50 ) = '',
	@idout int OUTPUT
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText )
	Values
	( 	--@idguid, 
		1, @dt, @sender, @receiver, @smstext )

	select @idout = cast ( @@identity as int )
end
GO
