
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_PlugIns' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_PlugIns' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LoadType' )
	Alter Table dbo.A_PlugIns
	Add LoadType int
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_PlugIns' ) )
	if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_PlugIns' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LoadType' )
	Update dbo.A_PlugIns 
	Set LoadType = 0
GO


if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_Save'))
	drop procedure dbo.A_PlugIns_Save
GO

Create procedure dbo.A_PlugIns_Save
	@id uniqueidentifier,
	@type int,
	@objectname nvarchar ( 400 ) = null,
	@name nvarchar ( 400 ),
	@description Text = null,
	@path nvarchar ( 1000 ) = null,
	@loadtype int = 0
as
begin
	Update A_PlugIns
	Set 	Type = @type,
		ObjectName = @objectname,
		Name = @name,
		Description = @description,
		Path = @path,
		LoadType = @loadtype
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_PlugIns ( Id, Type, ObjectName, Name, Description, Path, LoadType )
		Values ( @id, @type, @objectname, @name, @description, @path, @loadtype )
end
GO


if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_Delete'))
	drop procedure dbo.A_PlugIns_Delete
GO

Create procedure dbo.A_PlugIns_Delete
	@id uniqueidentifier	
as
begin
	Delete 
	From A_PlugIns
	Where Id = @id
end
GO



if exists ( Select * from sysobjects where id=object_id('dbo.A_PlugIns_GetAll'))
	drop procedure dbo.A_PlugIns_GetAll
GO

Create procedure dbo.A_PlugIns_GetAll
as
begin
	Select Id, Type, ObjectName, Name, Description, Path, LoadType
	From A_PlugIns
	Order by Name	
end
GO
