
/*   .   07.04.09*/
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_Load_RolesOfUsers' ) )
	Drop Procedure dbo.A_UserRoles_Load_RolesOfUsers
GO

Create Procedure dbo.A_UserRoles_Load_RolesOfUsers
As
Begin
	Select IdUser, IdRole, b.Domination From dbo.A_UserRoles_RolesOfUsers a
	left join
	(
		select * from A_UserRoles_Roles
	) b
	On a.IdRole = b.Id
	Where Domination is not null
End
GO

/*   +,      */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_RemoveOldRoles' ) )
	Drop Procedure dbo.A_UserRoles_RemoveOldRoles
GO

Create Procedure dbo.A_UserRoles_RemoveOldRoles
As
Begin
	delete from A_UserRoles_RolesOfUsers where IdRole not in (select id from A_UserRoles_Roles)
End
GO

/*    */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_AddRight' ) )
     Drop Procedure dbo.A_UserRoles_AddRight
GO

Create Procedure dbo.A_UserRoles_AddRight
 	@id uniqueidentifier,
	@knot nvarchar (100),
	@name nvarchar (200),
	@code nvarchar (100)
As
begin
	Update dbo.A_UserRoles_Rights
	Set
		Id = @id,
		Knot = @knot,
		Name = @name,
		Code = @code
	Where
		Id = @id

	if ( @@rowcount = 0 )
		Insert Into dbo.A_UserRoles_Rights (Id, Knot, Name, Code) values(@id, @knot, @name, @code)

end
GO