if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearIndexes' ) )
	Drop procedure A_DB_ClearIndexes
GO

Create procedure [dbo].[A_DB_ClearIndexes]
	@tablename nvarchar ( 500 )
as
begin
	
	declare @sql nvarchar(1000)

	DECLARE tcursor CURSOR FOR 
	Select name from sysindexes where id=object_id(@tablename) and impid >= 0 /*status!=0*/ and name not like '_WA%' and name not like 'PK_%'

	Declare @ind_name varchar(500)

	OPEN tcursor
	FETCH NEXT FROM tcursor INTO @ind_name

	WHILE @@FETCH_STATUS = 0
	BEGIN

		set @sql='drop index '+@tablename+'.'+@ind_name
		exec sp_executesql @stmt =@sql

		FETCH NEXT FROM tcursor INTO @ind_name
	END

	CLOSE tcursor
	DEALLOCATE tcursor
end
GO


exec dbo.A_DB_ClearIndexes 'dbo.A_User_NotifyLog'
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_User_NotifyLog' ) )
    if not exists ( select name from sysindexes where id=object_id('dbo.A_User_NotifyLog') and name = 'idxUserNotifies_UserDTWasShown' )
	CREATE INDEX idxUserNotifies_UserDTWasShown ON dbo.A_User_NotifyLog
	(
		IdUser, NotifyDateTime, WasShown
	) WITH FILLFACTOR = 80
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetAllUnShown_ForUser' ) )
	Drop procedure A_UserNotifyLog_GetAllUnShown_ForUser
GO

Create  Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
	@id uniqueidentifier
as
begin
	Declare @dtnow datetime
	set @dtnow = GetDate()

	Declare @dttoday datetime
	set @dttoday = Cast ( Floor ( cast ( @dtnow as float ) ) as DateTime )

	Select Top 15 * 
	From A_User_NotifyLog With ( Index ( idxUserNotifies_UserDTWasShown ) )--WITH ( TabLock, HoldLock )
	Where IDuser = @id and WasShown = 0 --and NotifyDateTime > @dttoday
	Order by NotifyDateTime Desc

	Update A_User_NotifyLog --with ( TABLOCK )
	Set WasShown = 1 
	Where IdUser = @id and WasShown = 0
end
GO