if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_CallBackOrders_Set' ) )
	Drop procedure dbo.A_CallBackOrders_Set
GO

Create Procedure [dbo].[A_CallBackOrders_Set]
	@idconn			uniqueidentifier,
	@clientid		uniqueidentifier,
	@calleddatetime		datetime,
	@isorderedtime		bit,
	@orderedtime		datetime,
	@orderednumber		nVarChar ( 20 ),
	@isspecifiedreciever	bit,
	@comment		nVarChar ( 1000 ),
	@done			bit,
	@doneuserid		uniqueidentifier,
	@viewed			bit,
	@recievernumber		nVarChar ( 20 )
as
begin
	declare @realclientid uniqueidentifier
	set @realclientid = @clientid
	
 	if ( @realclientid = '00000000-0000-0000-0000-000000000000' )
	begin

		Select @realclientid = c.Id FROM A_Clients c
			Inner join A_ClientContacts cc on c.Id = cc.IdClient
			Inner join A_ClientContactTypes cct on cc.IdContact = cct.Id
		Where IsPhoneNumber = 1 And 
		 	( cc.Content like @recievernumber or cc.Content like @orderednumber )
	end

	Insert 
	Into A_CallBackOrders 
	(	IDconn,
		ClientId,
		CalledDateTime,
	 	IsOrderedTime,
	  	OrderedTime,
		OrderedNumber,
		IsSpecifiedReciever,
		Comment,
		Done,
		DoneUserId,
		Viewed 	)
	Values
	(
		@idconn,
		@realclientid,
		@calleddatetime,
		@isorderedtime,
		@orderedtime,
		@orderednumber,
		@isspecifiedreciever,
		@comment,
		@done,
		@doneuserid,
		@viewed
	)

	if ( @isspecifiedreciever > 0 )
		Insert 
		Into A_CallBackRecievers ( IdConn, IntNumber )
			Values ( @idconn, @recievernumber )
	
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_ClientContacts' ) )
    if not exists ( select name from sysindexes where id=object_id('dbo.A_ClientContacts') and name = 'idxClientContacts_Content' )
	CREATE INDEX idxClientContacts_Content ON dbo.A_ClientContacts
	(
		Content
	) WITH FILLFACTOR = 80
GO

