if exists ( select * from sysobjects where id = object_id ( 'dbo.A_UserPhoto' ))
	Drop table dbo.A_UserPhoto
GO

Create table dbo.A_UserPhoto
(
	id uniqueidentifier primary key,
	photo image,
	modifieduser uniqueidentifier,
	modifieddt datetime
)
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserPhoto_GetAll' ))
	Drop procedure dbo.A_Admin_UserPhoto_GetAll
GO

Create procedure dbo.A_Admin_UserPhoto_GetAll
as
begin
	Select up.id,
		DataLength(up.photo) as Length, up.photo, 
		up.modifieddt, 
		up.modifieduser, IsNull ( u.Name, '' ) as modifiedusername
	From A_UserPhoto up
		Left join A_Users u on u.id = up.modifieduser
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserPhoto_Get' ))
	Drop procedure dbo.A_Admin_UserPhoto_Get
GO

Create procedure dbo.A_Admin_UserPhoto_Get
	@user uniqueidentifier
as
begin
	Select up.id, 
		DataLength(up.photo) as Length, up.photo, 
		up.modifieddt, 
		up.modifieduser, IsNull ( u.Name, '' ) as modifiedusername
	From A_UserPhoto up
		Left join A_Users u on u.id = up.modifieduser
	Where up.id = @user
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_UserPhoto_Save' ))
	Drop procedure dbo.A_Admin_UserPhoto_Save
GO

Create procedure dbo.A_Admin_UserPhoto_Save
	@user uniqueidentifier,
	@photo image = null,
	@modifieduser uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
	   Set @dtnow = GetDate()

	Update A_UserPhoto
	Set photo = @photo,
		modifieduser = @modifieduser,
		modifieddt = @dtnow
	Where id = @user

	if ( @@rowcount = 0 ) 
	   Insert into A_UserPhoto ( id, photo, modifieduser, modifieddt )
	   Values ( @user, @photo, @modifieduser, @dtnow )	
end
GO
