
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_SubTasks' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'RetryNumbers' )
	Alter Table dbo.A_TaskManager_SubTasks
	Add RetryNumbers nvarchar(200)
GO


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetTaskPointInfo' ) )
	Drop procedure [dbo].[A_TaskManager_List_GetTaskPointInfo]
GO

Create procedure [dbo].[A_TaskManager_List_GetTaskPointInfo]
	@idtask uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select IdInList, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime,
		RetryNumbers
	From A_TaskManager_SubTasks st --With ( TabLock )
	Where TaskId = @idtask
end
GO


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_Point' ) )
	Drop procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Point]
GO

Create Procedure dbo.A_TaskManager_TaskOut_UpdateResult_Point
	@idtask			uniqueidentifier,	
	@idinlist		int,
	@nextefforttime		datetime,
	@nresult		int,
	@retrynumbers		nvarchar(200) = NULL
as

begin	
	--Begin tran AAA

	update A_TaskManager_SubTasks --With ( TabLock, HoldLock )
	   set
		NextEffortTime 		= @nextefforttime,
		NResult			= @nresult,
		RetryNumbers		= @retrynumbers
	   where		
		TaskId = @idtask
		and IdInList = @idinlist

	if ( @@rowcount = 0 )
		Insert Into A_TaskManager_SubTasks --With ( TabLock )
			( IdInList, TaskId, NResult, IsDeleted, NextEffortTime, RetryNumbers )
		Values
			( @idinlist, @idtask, @nresult, 0, @nextefforttime, @retrynumbers )

	--Commit Tran AAA
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_CheckAddNumber
	@taskid uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 200 ),
	@table nvarchar ( 200 ),
	@query nvarchar ( 4000 ) = '',
	@colphone nvarchar ( 100 ),
	@colid nvarchar ( 100 ),
	@checkcondition nvarchar ( 1000 )
as
begin
	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	--         ,        . Sysobjects .
	--if exists ( Select * From sysobjects
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tt' ) )
		drop table #tt
	Create table #tt ( cnt int )

	Set @sql = 'Select Count ( * ) From '
	if ( Len ( @query ) > 0 )
		set @sql = @sql + ' ( ' + @query + ' ) t '
	else
		set @sql = @sql + @table + ' t '
	Set @sql = @sql + '		
		Where (' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ') and ( ' + @checkcondition + ' )'
	
	Insert into #tt
		Exec sp_executesql @sql	

	declare @cnt int
	Select @cnt = cnt from #tt

	if ( @cnt = 0 )
	begin
		--     -
		Set @sql = ' SET ROWCOUNT 1

			Declare @prec int

			Select @prec = prec 
			From syscolumns 
			Where id = object_id ( ''' + @table + ''' )

			Declare @newdata nvarchar(4000)

			Select @newdata = ' + @colphone + ' + '', ' + @number + ''' 
			From ' + @table + '
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			if ( Len ( @newdata ) <= IsNull ( @prec, 10000 ) ) begin

			   Update ' + @table + '
			   Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			   Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			end

			SET ROWCOUNT 0'


		-- . ,  ....
		Set @sql = ' SET ROWCOUNT 1
			Update ' + @table + '
			Set ' + @colphone + ' = ' + @colphone + ' + '', ' + @number + '''
			Where ' + @colid + ' = ' + cast ( @idinlist as nvarchar ( 10 ) ) + '

			SET ROWCOUNT 0'
	

		exec sp_executesql @sql

	
		set @sql = '
			if not exists ( select id from ' + @tableidxn + ' Where Id = ' + cast ( @idinlist as nvarchar ( 10 ) ) + ' and phone = ''' + @number + ''')
				Insert into ' + @tableidxn + ' 
				Values ( ' + cast ( @idinlist as nvarchar ( 10 ) ) + ', ''' + @number + ''' )'
		
		if exists ( Select * FROM sysobjects where id = object_id ( @tableidxn ) )
			exec sp_executesql @sql

		select 1
	end
end
GO


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetTaskPointInfo' ) )
	Drop procedure [dbo].[A_TaskManager_List_GetTaskPointInfo]
GO

Create procedure [dbo].[A_TaskManager_List_GetTaskPointInfo]
	@idtask uniqueidentifier,
	@idinlist int = null,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	if ( @idinlist is null ) begin

	    Select IdInList, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime,
		RetryNumbers
	    From A_TaskManager_SubTasks st --With ( TabLock )
	    Where TaskId = @idtask

	end else begin

	    Select IdInList, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime,
		RetryNumbers
	    From A_TaskManager_SubTasks st --With ( TabLock )
	    Where TaskId = @idtask
	  	and IdInList = @idinlist

	end	
end
GO


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetTaskNumberInfo' ) )
	Drop procedure [dbo].[A_TaskManager_List_GetTaskNumberInfo]
GO

Create procedure [dbo].[A_TaskManager_List_GetTaskNumberInfo]
	@idtask uniqueidentifier,
	@idinlist int = null,
	@number nvarchar ( 50 ) = null,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	if ( @idinlist is null ) begin

	    Select IdInList, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	    From A_TaskManager_SubTaskNumber stn --With ( TabLock )
	    Where TaskId = @idtask

	end else begin

	    Select IdInList, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, isnull ( NextEffortTime, @dtnow ) as NextEffortTime
	    From A_TaskManager_SubTaskNumber stn --With ( TabLock )
	    Where TaskId = @idtask
		and IdInList = @idinlist
		and (( @number is null ) or ( Number = @number ))

	end
end
GO